<?php
/**
 * Project of Engotheme.com
 * Author: EngoTheme
 */
/**
 * Filter default Layout
 */
add_filter( 'engo_engo_layout_options', 'engo_layout_options' );

function engo_layout_options() {

	return array( 'LM', 'MR', 'None' );
}

/**
 * Read More Button
 */
add_filter( 'engo_engo_layout_menu_label', 'engo_layout_menu_label' );

function engo_layout_menu_label() {

	return 'Blog Layout';
}

/**
 * Remove section frame theme
 */
add_filter( 'display_typography_body_content', create_function( '', 'return false;' ) );

add_filter( 'display_feature_image_section', create_function( '', 'return false;' ) );

add_filter( 'display_hight_light_paragraph_section', create_function( '', 'return false;' ) );

add_filter( 'display_author_box_section', create_function( '', 'return false;' ) );

add_filter( 'display_related_box_section', create_function( '', 'return false;' ) );

add_filter( 'display_share_box_section', create_function( '', 'return true;' ) );

add_filter( 'display_footer_content_section', create_function( '', 'return false;' ) );

add_filter( 'use_widget_footer_section', create_function( '', 'return false;' ) );

add_filter( 'use_menu_footer_section', create_function( '', 'return false;' ) );

add_filter( 'display_breadcrumb_section', create_function( '', 'return false;' ) );

add_filter( 'display_seo_module', create_function( '', 'return false;' ) );

/* Logo */
add_filter( 'logo_text', create_function( '', 'return false;' ) );
add_filter( 'enable_logo_image', create_function( '', 'return false;' ) );

/* Slogan */
add_filter( 'enable_slogan', create_function( '', 'return false;' ) );
add_filter( 'slogan_text', create_function( '', 'return false;' ) );

/**
 * Config Widgets
 */
/* hide widgets */
add_filter( 'hide_widgets', create_function( '', 'return array("twitter");' ) );

/* Display widgets default */
add_filter( 'engo_config_widgets', 'engo_config_widgets' );

function engo_config_widgets() {

	$new_configs = array(
		'flickr' => 1,
		'sound_clound' => 1,
	);
	return $new_configs;
}

/**
 * Customize Config
 */
/* logo & slogan */
add_filter( 'engo_customize_logo_slogo_section', 'engo_customize_logo_slogo_section' );

function engo_customize_logo_slogo_section() {

	return __( 'Logo Settings', 'lotus' );
}

add_filter( 'customize_enable_slogan', create_function( '', 'return false;' ) );
add_filter( 'customize_enable_logo_text', create_function( '', 'return false;' ) );
add_filter( 'customize_enable_image_checkbox', create_function( '', 'return false;' ) );
add_filter( 'display_typography_logo_slogan', create_function( '', 'return false;' ) );

/**
 * Framework Modules Config
 */
$frame_configs = array(
	'security' => 0,
	'widgets' => 1,
);
/**
 * New Theme Configs
 */
$theme_new_configs = array(
	'logo' => array(
		'image' => get_template_directory_uri() . '/assets/images/default/logo-small.png',
		'favicon' => get_template_directory_uri() . '/assets/images/default/favicon.png',
	),
	'logo_rentina' => array(
		'image' => get_template_directory_uri() . '/assets/images/default/logo-small.png',
	),
	'content' => array(
		'add-lead' => 0,
		'limit' => 0,
		'feature-image' => 0,
		'author-box' => 0,
		'related-box' => 0,
		'meta-box' => 1,
		'share-box' => 1,
		'show-cm' => 1,
	),
	'mailchimp' => array(
		'enable' => 1,
	),
	'twitter' => array(
		'enable' => 0,
	),
);

/**
 * Enable generate custom color css
 */
add_filter( 'enable_custom_color_css', create_function( '', 'return true;' ) );
$generate_custom_color = array(
	//use for generate custom color file css
	'color_default' => '#ffd34e',
	'file_source' => 'color.css',
	'file_name' => 'color-customs.css',
		//end custom color file
);
/**
 * Default Framework configs
 */
global $options_extra;
$min = (ENGO_DEBUG == true) ? '.min' : '';
$default_config = array(
	'support' => array(
		'skype' => array( 'theocean87', 'kidiwp', 'dangy1989', 'nguyen_dttn', 'lenanghai' ),
		'video' => '01Avrz-Q8ks',
		'doc' => 'http://engotheme.com/docs/',
		'forum' => 'http://engotheme.com/forum/theme-support/',
	),
	'generate_custom_color' => $generate_custom_color,
	'frame_options' => $frame_configs,
	'theme_options_name' => apply_filters( 'engo_get_option_by_lang', '"' . THEME_OPTIONS_NAME . '"' ),
	'theme_new_configs' => $theme_new_configs,
	'extra_options' => $options_extra,
	'menu_name' => array( 'Lotus Menu', 'My Account Menu' ),
	'menu_id' => 'main_menu',
	'contact_form_name' => 'Lotus Contact',
	'contact_option' => 'form',
	'homegpage_name' => 'Home 1',
	'blogpage_name' => 'Blog',
	'theme_option' => 'a:18:{s:5:"basic";a:3:{s:8:"post-nav";s:0:"";s:7:"favicon";s:0:"";s:8:"analytic";s:0:"";}s:11:"breadcrumbs";a:6:{s:8:"homepage";i:0;s:5:"posts";i:0;s:5:"pages";i:0;s:8:"archives";i:0;s:7:"404page";i:0;s:10:"attachment";i:0;}s:7:"comment";a:2:{s:5:"posts";i:0;s:5:"pages";i:0;}s:9:"trackback";a:2:{s:5:"posts";i:0;s:5:"pages";i:0;}s:4:"logo";a:8:{s:4:"text";s:8:"lotus";s:6:"slogan";s:8:"EngoTheme";s:13:"enable_slogan";i:1;s:12:"enable_image";i:1;s:5:"image";s:86:"http://testwp.engo7.com/lotustest/wp-content/themes/lotus/assets/images/logo2.png";s:12:"image_height";s:0:"";s:11:"image_width";s:0:"";s:7:"favicon";s:88:"http://testwp.engo7.com/lotustest/wp-content/themes/lotus/assets/images/default/favicon.png";}s:6:"header";a:4:{s:5:"image";i:0;s:8:"logo-url";s:0:"";s:6:"script";s:0:"";s:3:"css";s:0:"";}s:7:"content";a:12:{s:8:"archives";s:7:"content";s:5:"limit";s:1:"0";s:10:"image-size";s:9:"thumbnail";s:10:"entry_meta";i:1;s:9:"share-box";i:1;s:8:"entry_cm";i:1;s:7:"show-cm";i:1;s:13:"feature-image";i:0;s:8:"add-lead";i:0;s:8:"meta-box";i:0;s:10:"author-box";i:0;s:11:"related-box";i:0;}s:9:"mailchimp";a:3:{s:6:"enable";i:1;s:7:"api_key";s:0:"";s:7:"list_id";s:0:"";}s:6:"layout";a:3:{s:11:"shop_layout";s:2:"MR";s:11:"grid_layout";s:4:"grid";s:14:"product_layout";s:4:"None";}s:6:"footer";a:16:{s:6:"ft_app";s:3:"w_c";s:6:"ft_col";s:1:"4";s:9:"copyright";s:31:"Copyright (C) by EngoTheme.Com.";s:7:"payment";i:1;s:6:"paypal";i:1;s:10:"mastercard";i:1;s:4:"visa";i:1;s:8:"discover";i:1;s:4:"ebay";i:1;s:6:"script";s:0:"";s:7:"content";i:0;s:6:"layout";s:1:"1";s:6:"column";i:0;s:6:"widget";i:0;s:4:"menu";i:0;s:6:"remove";i:0;}s:4:"feed";a:4:{s:8:"feed-url";s:0:"";s:13:"feed-redirect";i:0;s:11:"cm-feed-url";s:0:"";s:16:"cm-feed-redirect";i:0;}s:7:"twitter";a:7:{s:6:"enable";i:0;s:8:"username";s:0:"";s:12:"consumer_key";s:0:"";s:15:"consumer_secret";s:0:"";s:12:"access_token";s:0:"";s:19:"access_token_secret";s:0:"";s:5:"limit";s:1:"5";}s:9:"site-very";a:2:{s:6:"google";s:0:"";s:4:"bing";s:0:"";}s:6:"social";a:15:{s:6:"enable";i:1;s:8:"facebook";a:2:{s:6:"enable";i:1;s:3:"url";s:34:"https://www.facebook.com/engotheme";}s:7:"twitter";a:2:{s:6:"enable";i:1;s:3:"url";s:29:"https://twitter.com/engotheme";}s:6:"google";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:6:"github";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:9:"instagram";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:9:"pinterest";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:8:"linkedin";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:5:"skype";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:6:"tumblr";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:5:"vimeo";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:8:"dribbble";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:6:"flickr";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:7:"youtube";a:2:{s:6:"enable";i:0;s:3:"url";s:0:"";}s:6:"button";a:4:{s:8:"facebook";a:1:{s:6:"enable";i:1;}s:6:"google";a:1:{s:6:"enable";i:1;}s:7:"twitter";a:1:{s:6:"enable";i:1;}s:9:"pinterest";a:1:{s:6:"enable";i:1;}}}s:4:"font";a:2:{s:6:"google";s:0:"";s:7:"typekit";s:0:"";}s:10:"typography";a:14:{s:4:"logo";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:6:"slogan";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:6:"navbar";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:2:"h1";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:2:"h2";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:2:"h3";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:2:"h4";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:2:"h5";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:2:"h6";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:1:"p";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:1:"a";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:4:"body";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:7:"content";a:7:{s:6:"enable";i:0;s:4:"font";s:0:"";s:4:"size";s:0:"";s:6:"weight";s:0:"";s:10:"lineheight";s:0:"";s:9:"transform";s:0:"";s:5:"color";s:0:"";}s:9:"site-link";a:2:{s:5:"color";s:0:"";s:11:"color-hover";s:0:"";}}s:5:"extra";a:8:{s:7:"page404";a:6:{s:10:"background";s:87:"http://testwp.engo7.com/lotustest/wp-content/themes/lotus/assets/images/default/bg-404.jpg";s:5:"title";s:9:"404 ERROR";s:4:"desc";s:66:"We\'re sorry, but the pageyou were looking for doesn\'t exist.";s:4:"text";s:21:"Back To Previous Page";s:4:"link";s:35:"http://testwp.engo7.com/lotustest";s:11:"form_status";i:0;}s:11:"headerstyle";i:1;s:6:"layout";a:6:{s:11:"theme_style";i:1;s:9:"bg_style1";i:1;s:5:"color";s:0:"";s:5:"image";s:0:"";s:9:"bg_repeat";i:1;s:9:"bg_style2";i:0;}s:10:"body_color";s:7:"#d5375f";s:4:"shop";a:4:{s:8:"numposts";s:1:"8";s:8:"wishlist";s:1:"4";s:7:"compare";s:1:"5";s:6:"enable";i:0;}s:7:"product";a:3:{s:6:"relate";i:1;s:6:"review";i:1;s:7:"cattags";i:1;}s:6:"header";a:1:{s:3:"css";s:0:"";}s:7:"sidebar";a:4:{s:15:"on_page_archive";s:5:"right";s:12:"on_blog_page";s:5:"right";s:14:"on_single_page";s:5:"right";s:7:"on_page";s:2:"no";}}s:12:"logo_rentina";a:1:{s:5:"image";s:86:"http://testwp.engo7.com/lotustest/wp-content/themes/lotus/assets/images/logo2.png";}}0',
	'options_demo' => array(
		'blog_header' => array( 'show' => 1, 'enable' => 1, 'type' => 'image', 'slider' => '', 'title' => 'Blog', 'style' => 'engo-title-2', 'image' => '#', 'parallax' => 1, 'overlay' => array( 'enable' => 0, 'color' => '' ), 'pattern' => array( 'enable' => 0, 'image' => '' ) ),
	),
	'widgets' => array(
		//sidebarSlug => widgets
		'blog-sidebar' => array(
			'search' => array( 0, array( 'title' => 'Search' ) ),
			'recentpost' => array( 0, array( 'title' => 'Recent Posts', 'number' => '5' ) ),
			'engo_event_widget' => array( 0, array( 'title' => 'Event', 'number' => '3' ) ),
			'engo_instagram_widget' => array( 0, array( 'title' => 'Instagram', 'username' => 'navi.ocean', 'number' => '9' ) ),
			'engo-recent-comments' => array( 0, array( 'title' => 'Latest comments', 'number' => '5' ) ),
			'categories' => array( 0, array( 'title' => 'Categories', 'count' => '1' ) ),
			'archives' => array( 0, array( 'title' => 'Archives' ) ),
			'tag_cloud' => array( 0, array( 'title' => 'Tags', 'taxonomy' => 'post_tag' ) ),
		),
		'product-sidebar' => array(
			'woocommerce_products' => array( 0, array( 'title' => 'Products' ) ),
		),
		'sidebar_footer' => array(
			'engo_recent_posts_widget' => array( 0, array( 'title' => 'Fashion JOURNAL', 'qty' => 3 ) ),
		),
		'sidebar_footer-2' => array(
			'categories' => array( 0, array( 'title' => 'PRODUCT Categories' ) ),
		),
		'sidebar_footer-3' => array(
			'engo_mailchimp_widget' => array( 0, array( 'title' => 'NEWSLETTER SIGNUP' ) ),
			'engo_follow_us_widget' => array( 0, array( 'title' => 'Follow us' ) ),
		),
		'sidebar_footer-4' => array(
			'woocommerce_products' => array( 0, array( 'title' => 'Sale product', 'number' => 3, 'show' => 'onsale' ) ),
		),
	),
	'menu_replace' => 'http://lotus.engotheme.com',
	'plugins' => array(
		array(
			'name' => __('Revolution Slider', 'lotus'), // The plugin name.
			'slug' => 'revslider', // The plugin slug (typically the folder name).
			'source' => 'http://plugins.engotheme.com/revslider.zip', // The plugin source.
			'required' => true, // If false, the plugin is only 'recommended' instead of required.
			'external_url' => '', // If set, overrides default API URL and points to an external URL.
			'version' => '5.3.1.5'
		),
		array(
			'name' => __('Visual Composer', 'lotus'), // The plugin name.
			'slug' => 'js_composer', // The plugin slug (typically the folder name).
			'source' => 'http://plugins.engotheme.com/js_composer.zip', // The plugin source.
			'required' => true, // If false, the plugin is only 'recommended' instead of required.
			'external_url' => '', // If set, overrides default API URL and points to an external URL.
			'version' => '5.0.1',
		),
		array(
			'name' => __('Contact Form 7', 'lotus'),
			'slug' => 'contact-form-7',
			'required' => true,
		),
		array(
			'name' => __('Woocommerce', 'lotus'),
			'slug' => 'woocommerce',
			'required' => true,
		),
		array(
			'name' => __('Lotus Plugin Require 1.3', 'lotus'),
			'slug' => 'lotus-require',
			'source' => 'http://plugins.engotheme.com/lotus-require.zip',
			'required' => true,
			'version' => '1.3',
		),
		array(
			'name' => __('AweBooking 2.6', 'lotus'),
			'slug' => 'awebooking',
			'source' => 'http://plugins.engotheme.com/awebooking_2.6.zip',
			'required' => true,
			'version' => '2.6',
		),
	),
);

/**
 * Main Framework filter
 */
add_filter( 'display_shortcodes_module', create_function( '', 'return false;' ) );
add_filter( 'display_widgets_module', create_function( '', 'return true;' ) );
add_filter( 'display_pagenotfound_module', create_function( '', 'return false;' ) );

/**
 * Initialize ENGO FrameWork
 */
include( get_template_directory() . '/Framework/ENGO-Framework.php' );
if ( class_exists( 'EngoFramework' ) ) {
	$ENGO = new EngoFramework( $default_config );
}

// Convert first letter of string
function engo_upperFirstChar( $t ) {

	$fChar = mb_substr( $t, 0, 1, 'UTF-8' );
	$fCharReplace = mb_convert_case( $fChar, MB_CASE_UPPER, 'UTF-8' );
	$c = 1;
	$t = str_replace( $fChar, $fCharReplace, $t, $c );
	return $t;
}
