<?php
add_action( 'header_logo', 'engo_get_logo' );
add_action( 'header_extra_information','engo_header_extra_information' );

if ( ! function_exists( 'wp_site_icon' ) ) {
	add_action( 'wp_head', 'engo_get_favicon' );
}


/**
 * Header Logo
 */
function engo_get_logo() {
	global $lotus_option;
	if ( $lotus_option['logo']['image'] != '' ) :
		?>
        <div class="header_logo">
			<a title="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>"
			   href="<?php echo esc_url( home_url( '/' ) ); ?>"><img
					src="<?php echo esc_url( $lotus_option['logo']['image'] ); ?>"
					alt="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>"></a>
        </div>

	<?php
	endif;
}

/**
 * Header Favicon
 */
function engo_get_favicon() {
	global $lotus_option;
	if ( $lotus_option['logo']['favicon'] != '' ) :
		echo '<link href="' . esc_url($lotus_option['logo']['favicon']) . '" rel="shortcut icon">';
	endif;
}

/**
 * Header Extra Information
 */
function engo_header_extra_information() {
	global $lotus_option;
	$data = isset( $lotus_option['extra'] ) ? $lotus_option['extra'] : '';
	if ( $data == '' ) {
		return;
	}
	$address = isset( $lotus_option['extra']['address'] ) ? $lotus_option['extra']['address'] : esc_html__( '225 Beach Street, Australian', 'lotus' );
	$phone = isset( $lotus_option['extra']['phone'] ) ? $lotus_option['extra']['phone'] : esc_html__( '1-548-854-8898', 'lotus' );
	if ( $address != '' ) :
	?>
		<span><i class="lotus-icon-location"></i><?php echo esc_html( $address ); ?></span>
	<?php endif; ?>

	<?php if ( $phone != '' ) : ?>
		<span><i class="lotus-icon-phone"></i><?php echo esc_html( $phone ); ?></span>
	<?php
	endif;
}



?>
