<?php

/**
 * Project of Engotheme.com
 * Author: EngoTheme
 */

/**
 * Loading scripts
 */

function engo_active_extra_font() {
	global $lotus_option;
	echo isset( $lotus_option['font']['google'] ) ? $lotus_option['font']['google'] : '' ;
}
add_action( 'wp_head','engo_active_extra_font' );


function engo_loading_script() {
	global $post;
	$url = get_template_directory_uri() . '/assets/js/';
	if ( is_singular() ) {
		wp_enqueue_script( 'comment-reply' );
	}
	/**
	 * Loading Library JS
	 */
		wp_enqueue_script( 'jquery-ui-accordion' );
		wp_enqueue_script( 'jquery-ui-tabs' );
		wp_enqueue_script( 'jquery-ui-datepicker' );
		wp_enqueue_script( 'bootstrap', $url . 'lib/bootstrap.min.js', array( 'jquery' ), null, true );


	wp_enqueue_script( 'html5', 'http://html5shim.googlecode.com/svn/trunk/html5.js' );
	wp_script_add_data( 'html5', 'conditional', 'lt IE 9' );
	wp_enqueue_script( 'mediaqueries', 'http://css3-mediaqueries-js.googlecode.com/svn/trunk/css3-mediaqueries.js' );
	wp_script_add_data( 'mediaqueries', 'conditional', 'lt IE 9' );

	wp_enqueue_script( 'bootstrap-select', $url . 'lib/bootstrap-select.js', array( 'jquery' ), null, true );
	wp_enqueue_script( 'owl-carousel', $url . '/lib/owl.carousel.js', array( 'jquery' ), '2015620', true );
	wp_enqueue_script( 'countdown', $url . 'lib/jquery.countdown.min.js', array( 'jquery' ), null, true );
	wp_enqueue_script( 'countTo', $url . 'lib/jquery.countTo.js', array( 'jquery' ), null, true );
	wp_enqueue_script( 'parallax', $url . 'lib/jquery.parallax-1.1.3.js', array( 'jquery' ), null, true );
	wp_enqueue_script( 'appear', $url . 'lib/jquery.appear.min.js', array( 'jquery' ), null, true );
	wp_enqueue_script( 'magnific-popup', $url . 'lib/jquery.magnific-popup.min.js', array( 'jquery' ), null, true );
	wp_enqueue_script( 'imgloadded', $url . 'lib/imagesloaded.min.js', array( 'jquery' ), null, true );
	/**
	 * Loading Main JS
	 */
	wp_register_script( 'engo-main-script', $url . 'scripts.js', array( 'jquery' ), null, true );
	wp_localize_script('engo-main-script','engo_main',array(
		'url' => admin_url( 'admin-ajax.php' ),
		'textDays'	=> __( 'Days', 'lotus' ),
		'textHours'	=> __( 'Hours', 'lotus' ),
		'textMinutes'	=> __( 'Minutes', 'lotus' ),
		'textSeconds'	=> __( 'Seconds', 'lotus' ),
	));
	wp_enqueue_script( 'engo-main-script' );
}
add_action( 'wp_enqueue_scripts', 'engo_loading_script', 100 );



function engo_google_font_url() {
	$font_url = '';

    /*
    Translators: If there are characters in your 'lotus' that are not supported
    by chosen font(s), translate this to 'off'. Do not translate into your own 'lotus'.
     */
    if ( 'off' !== _x( 'on', 'Google font: on or off', 'lotus' ) ) {
        $font_url = add_query_arg( 'family', urlencode( 'Hind:400,300,500,600|Montserrat:400,700' ), "//fonts.googleapis.com/css" );
    }
    return $font_url;
}


/**
 * Loading Style CSS
 */
function engo_loading_style() {
	global $lotus_option;
	$url = get_template_directory_uri() . '/assets/css/';
	/**
	 * Loading Main Style
	 */
		wp_enqueue_style( 'awesome', $url . 'lib/font-awesome.min.css', false, false );
		wp_enqueue_style( 'jqueryui', $url . 'lib/jquery-ui.min.css', false, false );

	wp_enqueue_style( 'bootstrap', $url . 'lib/bootstrap.min.css', false, false );
	wp_enqueue_style( 'lotusicon', $url . 'lib/font-lotusicon.css"', false, false);
	wp_enqueue_style( 'bootstrap-select', $url . 'lib/bootstrap-select.min.css', false, false );
	wp_enqueue_style( 'magnific-popup', $url . 'lib/magnific-popup.css"', false, false );
	wp_enqueue_style( 'engo-main-style', $url . 'style.min.css', false, false );

	$custom_css = '';

	$custom_color = ! empty( $lotus_option['extra']['custom_color'] ) ? $lotus_option['extra']['custom_color'] : '';
	if ( ! empty( $custom_color ) ) {
		$custom_css .= '
			.accomd-modations-room .text,
			.gallery-cat ul li:hover a, .gallery-cat ul li.active a,
			.footer .footer_top,
			.reservation,
			.engo-no-header-transparent .header_content,
			.header_mobile {
				background-color: ' . $custom_color . ';
			}
			.restaurant_item .text .price,
			.tabs-restaurant .ui-tabs-nav li:hover a, .tabs-restaurant .vc_tta-tabs-list li:hover a .vc_tta-title-text,
			.tabs-restaurant .vc_tta-tabs-list li.vc_active a .vc_tta-title-text, .tabs-restaurant .ui-tabs-nav li.ui-state-active a {
				color: ' . $custom_color . '
			}
			.tabs-restaurant .ui-tabs-nav li:before,
			.tabs-restaurant .vc_tta-tabs-list li:before {
				border-top-color: ' . $custom_color . ';
			}

			.header_content,
			.hentry .entry-media .count-date,
			.room_item-6 .text {
				background-color: ' . lotus_hex2rgba( $custom_color, 0.85 ) . ';
			}';
	}


	$custom_color = ! empty( $lotus_option['extra']['navigation_color'] ) ? $lotus_option['extra']['navigation_color'] : '';
	if ( ! empty( $custom_color ) ) {
		$custom_css .= '
			.engo-no-header-transparent .header_content,
			.header_content .menu > li .sub-menu li.current-menu-item > a,
			.header_content .menu > li .sub-menu li:hover > a,
			.header_top .sub-menu li:hover > a {
				background-color: ' . $custom_color . ';
			}
			.header_content,
			.header_mobile,
			.header_mobile .header_menu {
				background-color: ' . lotus_hex2rgba( $custom_color, 0.85 ) . ';
			}';
	}

	$custom_color = ! empty( $lotus_option['extra']['navigation_text_color'] ) ? $lotus_option['extra']['navigation_text_color'] : '';
	if ( ! empty( $custom_color ) ) {
		$custom_css .= '
			.header_content .menu > li > a,
			.header_top .sub-menu li:hover > a,
			.header_mobile .header_menu ul li a{
				color: ' . $custom_color . ';
			}';
	}


	$custom_color = ! empty( $lotus_option['extra']['footer_color'] ) ? $lotus_option['extra']['footer_color'] : '';
	if ( ! empty( $custom_color ) ) {
		$custom_css .= '
			.footer .footer_center,
			.footer .footer_bottom {
				background-color: ' . $custom_color . ';
			}';
	}



	$custom_color = ! empty( $lotus_option['extra']['footer_text_color'] ) ? $lotus_option['extra']['footer_text_color'] : '';
	if ( ! empty( $custom_color ) ) {
		$custom_css .= '
			.footer .widget p,
			.footer .widget a,
			.footer .footer_bottom p,
			.footer .widget .widget-title {
				color: ' . $custom_color . ';
			}';
	}


	$custom_css = apply_filters( 'lotus_custom_css', $custom_css );

	if ( $custom_css ) {
		wp_add_inline_style( 'engo-main-style', $custom_css );
	}

	wp_enqueue_style( 'google-font', engo_google_font_url() );
}

add_action( 'wp_enqueue_scripts', 'engo_loading_style' );

// Add Style to footer
function engo_style_footer(){
	$url = get_template_directory_uri() . '/assets/css/';
	wp_enqueue_style( 'owl-carousel', $url . 'lib/owl.carousel.css', array(), false );
}
add_action('wp_enqueue_scripts','engo_style_footer');


/**
 * Loading Admin JS
 */
add_action( 'admin_enqueue_scripts', 'engo_load_admin_script' );

function engo_load_admin_script($hook) {
	global $pagenow;
	$url = get_template_directory_uri() . '/assets/css/';
	if ( in_array( $pagenow, array( 'post.php', 'post-new.php' ) ) && is_admin() ) {
		wp_register_script(
			'engo_meta_box_script', //unique handle
			get_template_directory_uri() . '/assets/js/media_metabox.js', //location
			array( 'jquery' )  //dependencies
		);
	}
	// Enqueued script with localized data.
	wp_enqueue_script( 'engo_meta_box_script' );
	wp_enqueue_script( 'jquery-ui-datepicker' );
	if ( in_array( 'ENGO-Framework', $_REQUEST ) ) {
		wp_enqueue_style( 'jqueryui', get_template_directory_uri() . '/Framework/asset/css/jquery-ui.css', false, false );
	}
	if ( in_array( 'ENGO-Framework', $_REQUEST ) || in_array( 'ENGO-Modules', $_REQUEST ) || in_array( 'ENGO-Security', $_REQUEST ) || in_array( 'ENGO-Update', $_REQUEST ) || in_array( 'ENGO-ImportData', $_REQUEST ) ) {
		return;
	}

}



