<?php
defined( 'LANGUAGE' ) || define( 'LANGUAGE', 'engo_thumbnail' );
defined( 'ENGO_THUMBNAIL_DIR' ) || define( 'ENGO_THUMBNAIL_DIR', 'engo-thumbnail/' );
defined( 'ENGO_THUMBNAIL_INC_DIR' ) || define( 'ENGO_THUMBNAIL_INC_DIR', trailingslashit( get_template_directory() ) . ENGO_THUMBNAIL_DIR . 'inc/' );
defined( 'ENGO_THUMBNAIL_CSS_PATH' ) || define( 'ENGO_THUMBNAIL_CSS_PATH', trailingslashit( get_template_directory_uri() ) . ENGO_THUMBNAIL_DIR . 'assets/css/' );
defined( 'ENGO_THUMBNAIL_JS_PATH' ) || define( 'ENGO_THUMBNAIL_JS_PATH', trailingslashit( get_template_directory_uri() ) . ENGO_THUMBNAIL_DIR . 'assets/js/' );
defined( 'ENGO_THUMBNAIL_IMG_PATH' ) || define( 'ENGO_THUMBNAIL_IMG_PATH', trailingslashit( get_template_directory_uri() ) . ENGO_THUMBNAIL_DIR . 'assets/images/' );


require_once( ENGO_THUMBNAIL_INC_DIR . 'class-engo-thumbnail.php' );


function engo_init_thumbnail() {
	$args = array(
		'id'	=> 'engo-portfolio-thumbnail',
		'title'	=> __( 'Feature Thumbnail', 'lotus' ),
		'screen'	=> array( 'post' ),
		'fields'	=> array(
			'slider'	=> array(
				'type'	=> 'gallery',
				'title'	=> __( 'Slider', 'lotus' ),
			),
			'video'	=> array(
				'type'	=> 'video',
				'title'	=> __( 'Video', 'lotus' ),
			),
			'audio'	=> array(
				'type'	=> 'audio',
				'title'	=> __( 'Audio', 'lotus' ),
			),
		),
	);
	new ENGO_Thumbnail( $args );

	/*$args = array(
		'id'	=> 'inside-portfolio-media',
		'title'	=> __( 'Inside Portfolio Media', 'lotus' ),
		'screen'	=> array( 'portfolio' ),
		'fields'	=> array(
			'image'	=> array(
				'type'	=> 'image',
				'title'	=> __( 'Image', 'lotus' ),
			),
			'stack-image'	=> array(
				'type'	=> 'gallery',
				'title'	=> __( 'Stack Image', 'lotus' ),
			),
			'slider'	=> array(
				'type'	=> 'gallery',
				'title'	=> __( 'Slider', 'lotus' ),
			),
			'video'	=> array(
				'type'	=> 'video',
				'title'	=> __( 'Video', 'lotus' ),
			),
		),
	);
	new ENGO_Thumbnail( $args );*/
}

if (is_admin()) {
	add_action('load-post.php', 'engo_init_thumbnail');
	add_action('load-post-new.php', 'engo_init_thumbnail');
}