<?php
if (!defined( 'ABSPATH' ) ) die( '-1' );

abstract class engo_shortcode {

	protected $icon = '';

	protected function get_resource( $file, $path = '' ) {
		if ( $path == '' ) {
			$path = get_template_directory_uri() . '/engo_shortcode/shortcode/' . get_class( $this ) . '/';
		} else if ( $path == 'css' ) {
			$path = get_template_directory_uri() . '/engo_shortcode/assets/css/';
		} else if ( $path == 'js' ) {
			$path = get_template_directory_uri() . '/engo_shortcode/assets/js/';
		} else if ( $path == 'images' ) {
			$path = get_template_directory_uri() . '/engo_shortcode/assets/images/';
		} else if ( $path == 'assets' ) {
			$path = get_template_directory_uri() . '/engo_shortcode/assets/';
		} else if ( $path == 'vendors' ) {
			$path = get_template_directory_uri() . '/engo_shortcode/assets/vendors/';
		}
		return $path . $file;
	}

	public function load_script( $name = '', $url = '', $deps = '' ) {
		if ( '' == $name ) {
			$name = get_class( $this );
		}
		if ( '' == $url ) {
			$url = get_template_directory_uri() . '/engo_shortcode/shortcode/' . get_class( $this ) . '/script.js';
		}
		wp_enqueue_script( $name, $url, $deps, '1.0' );
	}

	public function getId() {
		return (int) mt_rand( 0, 100 );
	}

	protected function animation() {
		return $array = array(
			__( 'No', 'lotus' ) => '',
			__( 'FadeIn', 'lotus' ) =>'fadeIn',
			__( 'FadeInDown', 'lotus' ) => 'fadeInDown',
			__( 'FadeInDownBig', 'lotus' ) => 'fadeInDownBig',
			__( 'FadeInLeft', 'lotus' ) => 'fadeInLeft',
			__( 'FadeInLeftBig', 'lotus' ) => 'fadeInLeftBig',
			__( 'FadeInRight', 'lotus' ) => 'fadeInRight',
			__( 'FadeInRightBig', 'lotus' ) => 'fadeInRightBig',
			__( 'FadeInUp', 'lotus' ) => 'fadeInUp',
			__( 'FadeInUpBig', 'lotus' ) => 'fadeInUpBig',
			__( 'FadeInhalf-text', 'lotus' ) => 'fadeInhalf-text',
			__( 'FadeInhalf-symbolBig', 'lotus' ) => 'fadeInhalf-symbolBig',
			__( 'BounceIn', 'lotus' ) => 'bounceIn',
			__( 'BounceInDown', 'lotus' ) => 'bounceInDown',
			__( 'BounceInLeft', 'lotus' ) => 'bounceInLeft',
			__( 'BounceInRight', 'lotus' ) => 'bounceInRight',
			__( 'BounceInUp', 'lotus' ) => 'bounceInUp',
			__( 'Flash', 'lotus' ) => 'flash',
			__( 'Pulse', 'lotus' ) => 'pulse',
			__( 'RubberBand', 'lotus' ) => 'rubberBand',
			__( 'Shake', 'lotus' ) => 'shake',
			__( 'Swing', 'lotus' ) => 'swing',
			__( 'Tada', 'lotus' ) => 'tada',
			__( 'Wobble', 'lotus' ) => 'wobble',
			__( 'Flip', 'lotus' ) => 'flip',
			__( 'FlipInX', 'lotus' ) => 'flipInX',
			__( 'FlipInY', 'lotus' ) => 'flipInY',
			__( 'LightSpeedIn', 'lotus' ) => 'lightSpeedIn',
			__( 'RotateIn', 'lotus' ) => 'rotateIn',
			__( 'RotateInDownLeft', 'lotus' ) => 'rotateInDownLeft',
			__( 'RotateInDownRight', 'lotus' ) => 'rotateInDownRight',
			__( 'RotateInUpLeft', 'lotus' ) => 'rotateInUpLeft',
			__( 'RotateInDownRight', 'lotus' ) => 'rotateInUpRight',
			__( 'SlideInDown', 'lotus' ) => 'slideInDown',
			__( 'SlideInLeft', 'lotus' ) => 'slideInLeft',
			__( 'SlideInRight', 'lotus' ) => 'slideInRight',
			__( 'RollIn', 'lotus' ) => 'rollIn',
		);
	}

	protected function animation_class( $animation ) {
		if ( $animation ) {
			return 'wow ' . $animation . ' animated';
		} else {
			return '';
		}
	}

	protected function icon( $icon = 'shortcode.png' ) {
		return $this->get_resource( $icon, 'images' );
	}

	public function custom_shortcode( $tag, $func ) {
		global $shortcode_tags;

		if ( is_callable( $func) ) {
			$shortcode_tags[ $tag ] = $func;
		}
	}

	abstract function engo_vc_shortcode();

	abstract function engo_render_html( $atts, $content= '' );

	public function engo_show_admin_notice() {
		if ( ! defined( 'WPB_VC_VERSION' ) ) {
			?>
			<div class="updated">
				<p><strong>Lotus Theme</strong> requires <strong><a href="#" target="_blank">Visual Composer</a></strong> plugin to be installed and activated on your site</p>
			</div>';
			<?php
		}
	}

	public function order_way_values(){
		return $order_way_values = array(
			'',
			__( 'Descending', 'lotus' ) => 'DESC',
			__( 'Ascending', 'lotus' ) => 'ASC',
		);
	}

	public function order_by_values(){
		return $order_by_values = array(
			'',
			__( 'Date', 'lotus' ) => 'date',
			__( 'ID', 'lotus' ) => 'ID',
			__( 'Author', 'lotus' ) => 'author',
			__( 'Title', 'lotus' ) => 'title',
		);
	}
}


function engo_save_postmeta( $meta_key = '', $meta_value = '', $post_id = 0, $echo = true ) {
   
	$meta_key = isset( $_POST['meta_key'] ) ? sanitize_key( $_POST['meta_key'] ) : $meta_key;
	$meta_value = isset( $_POST['meta_value'] ) ? $_POST['meta_value'] : $meta_value;
	$post_id = isset( $_POST['post_id'] ) ? absint( $_POST['post_id'] ) : $post_id;
	$meta_id = (isset( $_POST['meta_id'] ) && $_POST['meta_id'] != '' ) ? absint( $_POST['meta_id'] ) : 0;

	$meta_value = str_replace( array( '\\\'', '\\"', '\\\\' ), array( '\'', '"', '\\' ), $meta_value );
	$arr = '-'; 
	if ( $meta_key != '' && $meta_value != '' && $post_id > 0 ) {
		global $wpdb;
		$count = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(*) FROM $wpdb->postmeta WHERE meta_id = %d", absint( $meta_id ) ) );
		if ( $count > 0 ) {
			$wpdb->update(
				$wpdb->postmeta,
				array(
					'post_id'       => $post_id,
					'meta_key'      => $meta_key,
					'meta_value'    => $meta_value
				),
				array( 'meta_id' => $meta_id ),
				array( '%d', '%s', '%s' ),
				array( '%d' )
			);
			$arr = array(
				'status' => 'update_success',
				'message' => 'Saved'
			);
		   

		} else {
			$wpdb->insert(
				$wpdb->postmeta,
				array(
					'post_id'       => $post_id,
					'meta_key'      => $meta_key,
					'meta_value'    => $meta_value
				),
				array( '%d', '%s', '%s' )
			);
			$arr = array(
				'status'    => 'insert_success',
				'message'   => $wpdb->insert_id
			);
		}
		if( $echo == true ) {
			echo json_encode( $arr );
			die();
		} else {
			return $arr;
		}
	}
}

add_action( 'wp_ajax_engo_save_postmeta', 'engo_save_postmeta' );
