var Engo_dialog = {};
(function ($) {
    'use strict';
    $(document).on('click', '.Engo_dialog .media-modal-close', function (e) {
        Engo_dialog.close();
        e.preventDefault();
    });
    /*
     *@Event Tab select 
     */
    $(document).on('click', '.Engo_dialog .media-router a', function (e) {
        if (!$(this).hasClass('active')) {
            //Changed nav
            $(".engo-modal .media-router a").removeClass("active");
            $(this).addClass('active');
            var id = $(this).attr('href').replace('#', '');
            //Changed content
            $(".engo-modal-content.active").removeClass('active');
            $(".engo-modal #engo_" + id).addClass('active');
            if (Engo_dialog.contentIsEmpty(id)) {
                window[Engo_dialog.addon].print(id);
            }
        }
        e.preventDefault();
    });

    //On Click item
    $(document).on('click', '.Engo_dialog .Engo_dialog_list a', function (e) {

        var $this = $(this);
        var id = $this.attr('data-id');
        var Addon = window[Engo_dialog.addon];
        
        if (Engo_dialog.multiSelect) {

            if (!$this.hasClass('selected')) {

                $this.addClass('selected');
                Addon.values[id] = $this.attr('data-data');
            } else {

                $this.removeClass('selected');
                delete Addon.values[id];
                //Remove tag in selected items
                if ($this.closest('#engo_itemselected').length) {
                    $this.parent().remove();
                }

            }

            var counter = Object.keys(Addon.values).length;
            Engo_dialog.setCounter(counter);
            if (counter > 0) {
                $(".Engo_icon .Engo_insert").removeAttr('disabled');
                Engo_dialog.find('.edit-selection').show();
                Engo_dialog.find('.clear-selection').show();
            } else {
                $(".Engo_icon .Engo_insert").attr('disabled', 'disabled');
                Engo_dialog.find('.edit-selection').hide();
                Engo_dialog.find('.clear-selection').hide();
            }

            /*
             *@Update list preview 
             */

            if (typeof Addon.printReview == 'function') {
                Addon.printReview();
            }

        } else {

            Engo_icon.values = {};
            Engo_icon.values[id] = $this.attr('title');
            Engo_dialog.onInserted(Addon.values);
            Engo_dialog.close();
        }

        e.preventDefault();
    });
    /*
     *@On insert 
     */
    $(document).on('click', ".Engo_dialog .Engo_insert", function (e) {
        //call back onInsert
        var Addon = window[Engo_dialog.addon];
        if (typeof Addon.onInsert == 'function') {
            Addon.onInsert(e);
        }
        if (Object.keys(Addon.values).length) {
            Engo_dialog.onInserted(Addon.values);
            Engo_dialog.close();
        }
        e.preventDefault();
    });
    /*
     *@On clear all 
     */
    $(document).on('click', ".Engo_dialog .clear-selection", function (e) {
        //call back onClear
        var Addon = window[Engo_dialog.addon];
        if (typeof Addon.onClear == 'function') {
            Addon.onClear(e);
        }

        Engo_dialog.valueSelected = {};
        Engo_dialog.find('.Engo_insert').attr('disabled', 'disabled');

        /*
         *@Update list preview 
         */
        if (typeof Addon.printReview == 'function') {
            Addon.printReview();
        }

        e.preventDefault();
    });
    /*
     *@On edit selection 
     */
    $(document).on('click', ".Engo_dialog .edit-selection", function (e) {
        var $this = $(this);
        if (!$this.hasClass('back')) {

            $this.addClass('back').html('<i class="fa fa-angle-double-left"></i> Back to library');
            Engo_dialog.find('.clear-selection').hide();
            Engo_dialog.find('.media-router .media-menu-item').hide();
            if (Engo_dialog.find('.media-router .item_selected').length) {
                Engo_dialog.find('.media-router .item_selected').show();
            } else {
                Engo_dialog.find('.media-router').append('<a href="#itemselected" class="media-menu-item item_selected active">Item selected</a>');
            }

            Engo_dialog.find('.media-frame-content .engo-modal-content.active').addClass('bookmark').removeClass('active'); //Bookmark

            if (Engo_dialog.find('.media-frame-content #engo_itemselected').length) {
                Engo_dialog.find('.media-frame-content #engo_itemselected').addClass('active');
            } else {
                Engo_dialog.find('.media-frame-content').append('<div id="engo_itemselected" class="engo-modal-content active"></div>');
            }

            window[Engo_dialog.addon]['printSelected']();
        } else {
            $this.removeClass('back').text('Edit Selection');
            Engo_dialog.find('.clear-selection').show();
            Engo_dialog.find('.media-router .media-menu-item').show();
            Engo_dialog.find('.media-menu-item.item_selected').hide();
            Engo_dialog.find('#engo_itemselected').removeClass('active');
            Engo_dialog.find(".engo-modal-content.bookmark").addClass('active').removeClass('bookmark'); //Remove bookmark

        }

        e.preventDefault();
    });

    Engo_dialog = {
        addon: '',
        multiSelect: false,
        find: function (selector) {
            return $("#" + this.addon + " " + selector);
        },
        isOpen: function () {
            return this.self.length;
        },
        close: function () {
            $("#" + this.addon).parent().hide();
        },
        setCounter: function (count) {
            this.find(".Engo_counter span").text(count);
        },
        setContent: function (id_content, html) {
            this.find("#engo_" + id_content).html(html);
        },
        contentChanged: function (id_content) {
            //abstract method
        },
        onInserted: function (value) {
            //abstract method
        },
        contentIsEmpty: function (key) {
            if ($("#" + this.addon + " #engo_" + key).is(":empty")) {
                return true;
            }
            return false;
        },
        showWait: function () {
            this.find('.Engo_spiner').show();
        },
        hideWait: function () {
            this.find('.Engo_spiner').hide();
        },
        open: function (options) {
            var params = {
                addon: '',
                title: "Media panel name",
                buttonInsert: 'Insert item',
                multiSelect: false,
                valueSelected: {},
                tabs: {
                    tab1: "Tab item 1",
                    tab2: "Tab item 2"
                }
            };
            $.extend(params, options);
            if (params.addon == '') {
                alert('Engo dialog not allow a addon param is null');
                return false;
            }

            this.multiSelect = params.multiSelect;
            this.addon = params.addon;
            //Set values selected to Addon
            window[this.addon].values = params.valueSelected;
            //Set seft to object element
            this.self = jQuery("#" + params.addon);
            if (this.isOpen()) {

                /*
                 *@Show the existed dialog 
                 */
                this.self.parent().show();
                /*
                 *@Active the first tab if Tab in selected item tab 
                 */
                if (this.find('.edit-selection.back').length) {
                    this.find('.edit-selection.back').removeClass('back').text('Edit Selection');
                    this.find('.clear-selection').show();
                    this.find('.media-router .media-menu-item').show();
                    this.find('.media-menu-item.item_selected').hide();
                    this.find('#engo_itemselected').removeClass('active');
                    this.find(".engo-modal-content.bookmark").addClass('active').removeClass('bookmark'); //Remove bookmark
                }

                /*
                 * @Update counter
                 */
                var Addon = window[this.addon];
                var counter = Object.keys(Addon.values).length;
                this.setCounter(counter);
                /*
                 * 
                 * @Update selected items in list
                 */
                if (counter) {
                    this.find('.Engo_dialog_list li a').removeClass('selected');
                    $.each(this.find('.Engo_dialog_list li a'), function (index, item) {
                        var id = $(this).attr('data-id');
                        if (Addon.values[id.toString()]) {
                            $(this).addClass('selected');
                        }
                    });
                }

            } else {
                var tabs = '';
                var content = '';
                var i = 0;
                $.each(params.tabs, function (key, value) {
                    i++;
                    var active = "";
                    if (i === 1) {
                        active = "active";
                    }
                    tabs += '<a href="#' + key + '" class="media-menu-item ' + active + '">' + value + '</a>';
                    content += '<div id="engo_' + key + '" class="engo-modal-content ' + active + '"></div>';
                });
                var footer = '<div class="media-frame-toolbar">\n\
                    <div class="media-toolbar">\n\
                        <div class="media-toolbar-secondary">\n\
                        <div class="media-selection">\n\
                        <div class="selection-info">\n\
                                <span class="Engo_counter count"><span>0</span> selected</span>\n\
                                        <a class="edit-selection" href="#">Edit Selection</a>\n\
                                        <a class="clear-selection" href="#">Clear</a>\n\
                        </div>\n\
                        <div class="selection-view">\n\
                                <ul tabindex="-1" class="attachments"></ul>\n\
                        </div></div></div>\n\
                          <div class="media-toolbar-primary">\n\
                              <a href="#" class="Engo_insert button media-button button-primary button-large media-button-insert" disabled="disabled">' + params.buttonInsert + '</a>\n\
                        </div>\n\
                    </div>\n\
                </div>';
                var html = '<div tabindex="0" class="supports-drag-drop" style="position: relative;">\n\
	<div id="' + params.addon + '" class="Engo_dialog ' + params.addon + ' media-modal wp-core-ui engo-modal">\n\
		<a class="media-modal-close" href="#">\n\
			<span class="media-modal-icon"><span class="screen-reader-text">Close media panel</span></span>\n\
		</a>\n\
		<div class="media-modal-content">\n\
			<div class="media-frame mode-select wp-core-ui hide-menu">\n\
				<div class="media-frame-title">\n\
					<h1>' + params.title + '<span class="dashicons dashicons-arrow-down"></span></h1>\n\
				</div>\n\
				<div class="media-frame-router">\n\
					<div class="media-router">' + tabs + '</div>\n\
				</div>\n\
				<div class="media-frame-content"><div class="Engo_spiner"></div>' + content + '</div>' + footer + '\n\
			</div>\n\
		</div>\n\
                    </div>\n\
                    <div class="media-modal-backdrop"></div>\n\
            </div>';
                $("body").append(html);

                //Print first tab
                var flag = false;
                for (var id_content in params.tabs) {
                    if (flag == false) {
                        window[params.addon].print(id_content);
                        flag = true;
                    }
                }
            }

            if (Object.keys(params.valueSelected).length) {

                this.find('.Engo_insert').removeAttr('disabled');

                /*
                 *@Print preview list 
                 */
                var Addon = window[Engo_dialog.addon];
                if (typeof Addon.printReview == 'function') {
                    Addon.printReview();
                }

            } else {
                Engo_dialog.find('.clear-selection').hide();
                Engo_dialog.find('.edit-selection').hide();
            }
        }
    };
})(jQuery);


var Engo_icon = {};
(function ($) {
    'use strict';

    /*Event group filter*/
    $(document).on('click', '.Engo_icon ul.group li a', function (e) {
        var $this = $(this);
        var filter = $this.attr('href').replace('#', '');
        $(".Engo_icon ul.group li a").removeClass('selected');
        $this.addClass('selected');
        if (filter == "all-icons") {
            $(".Engo_icon ul.list li").show();
        } else {
            $(".Engo_icon ul.list li").hide();
            $(".Engo_icon ul.list li." + filter).show();
        }


        e.preventDefault();
    });

    /*
     *@Engo dialog by Vu tuan
     */
    Engo_icon = {
        values: {},
        print: function (id_content) {

            var url = Engo.themeurl + '/Framework/asset/icons/data/';
            Engo_dialog.showWait();
            $.ajax({
                url: url + id_content + ".json",
                dataType:'json',
                success: function (data) {

                    data = Engo_icon.reFormat(data);
                    var element = '';
                    var group = '';
                    $.each(data.icons, function (key, item) {

                        var selected = (Engo_icon.values[item.id]) ? 'selected' : ''; //Active selected item

                        element += '<li class="' + item.categories + '">\n\
                                        <a href="#" class="' + selected + '" data-id="' + item.id + '" data-data="' + item.name + '" title="' + item.name + '">\n\
                                            <button class="list-check"><span></span></button>\n\
                                            <span class="list-icon"><i class="' + item.id + '"></i></span><span class="name">' + item.name + '</span>\n\
                                            <span class="filters" style="opacity: 0;">' + item.filter + '</span>\n\
                                        </a>\n\
                                    </li>';
                    });
                    $.each(data.groups, function (key, item) {
                        group += '<li><a href="#' + key + '">' + item + '</a></li>';
                    });
                    Engo_dialog.setContent(id_content,
                            '<div class="list-wrapper"><ul class="Engo_dialog_list list">' + element + '</ul></div>\n\
                                <div class="media-sidebar">\n\
                                    <h3>Search icons</h3>\n\
                                    <input class="search" type="search" placeholder="Search icons..."/>\n\
                                    <h3>Search by category</h3>\n\
                                    <ul class="group">' + group + '</ul>\n\
                            </div>');
                    Engo_dialog.setCounter(Object.keys(Engo_icon.values).length);
                    new List("engo_" + id_content, {page: 750, valueNames: ['name', 'filters']});
                    Engo_dialog.hideWait();
                }
            });
        },
        printSelected: function () {

            var element = '';
            $.each(this.values, function (id, name) {
                element += '<li>\n\
                                        <a href="#" class="selected" data-id="' + id + '" title="' + name + '">\n\
                                            <button class="list-check"><span></span></button>\n\
                                            <span class="list-icon"><i class="' + id + '"></i></span><span class="name">' + name + '</span>\n\
                                        </a>\n\
                                    </li>';
            });
            var html = '<div class="list-wrapper"><ul class="list">' + element + '</ul></div>';
            Engo_dialog.setContent('itemselected', html);
        },
        printReview: function () {
            var element = '';
            $.each(this.values, function (id, name) {
                element += '<li class="item-preview" title="' + name + '"><i class="' + id + '"></i></li>';
            });
            Engo_dialog.find('.selection-view ul').html(element);
        },
        reFormat: function (data) {
            var groups = {
                'all-icons': 'All icons'
            };
            $.each(data.icons, function (i, item) {


                if (!item.filter) {
                    item.filter = item.id;
                } else {
                    item.filter = item.filter.join(' ')
                }

                if (item.categories) {
                    $.each(item.categories, function (j, jitem) {
                        var key = Engo.replaceAll(jitem,' ', '-').toLowerCase();
                        groups[key] = jitem;
                        item.categories[j] = key;
                    });
                    item.categories = item.categories.join(' ');
                } else {
                    item.categories = 'all-icons';
                }
            });
            return {
                groups: groups,
                icons: data.icons
            };
        },
        onClear: function (e) {
            Engo_dialog.find(".list a.selected").removeClass('selected');
            this.values = {};
            Engo_dialog.setCounter(Object.keys(this.values).length);
        },
        onInsert: function (e) {

        },
    };
})(jQuery);
