(function($) {
	"use strict";

	if ($('.engo-reservation-date').length) {
		var inputDateFormat = $('input[name=\'txtDateFormat\']').val();
		var dateFormat = 'mm/dd/yy';

		switch (inputDateFormat) {
			case 'dd/mm/yyyy':
				dateFormat = 'dd/mm/yy';
			break;
			case 'yyyy/mm/dd':
				dateFormat = 'yy/mm/dd';
			break;
			case 'yyyy/dd/mm':
				dateFormat = 'yy/dd/mm';
			break;
		}

		$('.engo-reservation-date').datepicker('destroy');
		$('.engo-reservation-date').datepicker({
			dateFormat: dateFormat,
      constrainInput: true,
      minDate: 0,
      // prevText: '<i class="lotus-icon-left-arrow"></i>',
      // nextText: '<i class="lotus-icon-right-arrow"></i>',
      buttonImageOnly: false,
      beforeShow: function(input, inst) {
        $('#ui-datepicker-div').addClass('engo-datepicker');
      },

      onSelect: function(dateText) {
        if ($(this).hasClass('de-date')) {
          dateText = dateText.replace(/\//g, '.');
        }
        $(this).next().val(dateText);
      },
		});
	}

	if ($(".engo-reservation-form").length) {
		$(".engo-reservation-form").on('submit', function() {
			var $form = $(this);
			var check = true;
			var dateInput = $form.find("input[name='startDate']");
			var timeInput = $form.find("select[name='ResTime']");
			var perInput = $form.find("input[name='partySize']");

			// check date input
			if (dateInput.val() == "") {
				if (dateInput.parent().children('p').length) {
					dateInput.parent().children('p').show();
				} else {
					var p = $('<p class="error">' + ReservationForm.textErrorDate + '</p>');
					dateInput.parent().append(p);
				}
				// $form.find('.engo-calendar').addClass('has-error');
				check = false;
			} else {
				dateInput.parent().children('p').hide();
				// $form.find('.engo-calendar').removeClass('has-error');
			}

			// check time input
			if (timeInput.val() == 0) {
				if (timeInput.parent().children('p').length) {
					timeInput.parent().children('p').show();
				} else {
					var p = $('<p class="error">' + ReservationForm.textErrorTime + '</p>');
					timeInput.parent().append(p);
				}
				// $form.find('.bootstrap-select.engo-select > button').addClass('has-error');
				check = false;
			} else {
				timeInput.parent().children('p').hide();
				// $form.find('.bootstrap-select.engo-select > button').removeClass('has-error');
			}

			// check pers input
			if (perInput.val() == "") {
				if (perInput.parent().children('p').length) {
					perInput.parent().children('p').show();
				} else {
					var p = $('<p class="error">' + ReservationForm.textErrorPerson + '</p>');
					perInput.parent().append(p);
				}
				// perInput.addClass('has-error');
				check = false;
			} else {
				perInput.parent().children('p').hide();
				// perInput.removeClass('has-error');
			}

			if (!check)
				return false;
		});
	}

})(jQuery);
