<?php
/**
 * Created by PhpStorm.
 * User: EngoTheme
 */

/**
 *Initializing Funtion of Room after Engobooking actived
 */

// Room Item 1
if ( ! function_exists( 'lotus_room_item_1' ) ) {
	function lotus_room_item_1( $data ) {
		$rt_id   = isset( $data['rt_id'] ) ? $data['rt_id'] : 0;
		$link = get_permalink( $rt_id );
		if ( $rt_id == 0 ) {
			return;
		}
		?>
		<!-- ITEM -->
		<div class="col-md-6">
			<div class="room_item-1">

				<h2>
					<a href="<?php echo esc_url( $link ); ?>"><?php echo esc_html( get_the_title( $rt_id ) ); ?></a>
				</h2>

				<div class="img">
					<a href="<?php echo esc_url( $link ); ?>"><?php echo get_the_post_thumbnail( $rt_id, 'engo-room-slider' ); ?></a>
				</div>

				<div class="desc">
					<?php echo wp_kses_post( wpautop( get_post_meta( $rt_id, 'room_desc', true ) ) ); ?>
				</div>

				<div class="bot">
					<?php if ( ! empty( $data['start_price'] ) ) : ?>
						<span class="price">
							<?php
							printf( esc_html__( 'Starting %s/day', 'lotus' ), wp_kses_post( lotus_price( $data['start_price'] ) ) )
							?>
						</span>
					<?php endif; ?>
					<a href="<?php echo esc_url( $link ); ?>" class="engo-btn engo-btn-13"><?php esc_html_e( 'VIEW DETAILS', 'lotus' ); ?></a>
				</div>

			</div>
		</div>
		<!-- END / ITEM -->
		<?php
	}
}

// Room Item 2
if ( ! function_exists( 'lotus_room_item_2' ) ) {
	function lotus_room_item_2( $data ) {
		$rt_id   = isset( $data['rt_id'] ) ? $data['rt_id'] : 0;
		$link = get_permalink( $rt_id );
		if ( 0 == $rt_id ) {
			return;
		}
		$class = ( 0 == $data['i'] % 2 ) ? ' img-right' : '';
		?>
		<!-- ITEM -->
		<div class="room_item-2<?php echo esc_attr( $class ); ?>">
			<div class="img">
				<a href="<?php echo esc_url( $link ); ?>"><?php echo get_the_post_thumbnail( $rt_id, 'engo-room-slider' ); ?></a>
			</div>
			<div class="text">
				<h2>
					<a href="<?php echo esc_url( $link ); ?>"><?php echo esc_html( get_the_title( $rt_id ) ); ?></a>
				</h2>
				<?php if ( ! empty( $data['start_price'] ) ) : ?>
					<span class="price">
						<?php
						printf( esc_html__( 'Start from %s per day', 'lotus' ), wp_kses_post( lotus_price( $data['start_price'] ) ) )
						?>
					</span>
				<?php endif; ?>
				<?php echo wp_kses_post( wpautop( get_post_meta( $rt_id, 'room_desc', true ) ) ); ?>
				<a href="<?php echo esc_url( $link ); ?>" class="engo-btn engo-btn-13"><?php esc_html_e( 'VIEW DETAILS', 'lotus' ); ?></a>
			</div>
		</div>
		<!-- ITEM -->
		<?php
	}
}

// Room Item 3.
if ( ! function_exists( 'lotus_room_item_3' ) ) {
	function lotus_room_item_3( $data ) {
		$rt_id   = isset( $data['rt_id'] ) ? $data['rt_id'] : 0;
		$link = get_permalink( $rt_id );
		$image2       = get_post_meta( $rt_id, '_feature_image_second', true );
		$thumb_second = wp_get_attachment_image_src( $image2, 'full' );
		if ( $rt_id == 0 ) {
			return;
		}
		$class = ( 0 == $data['i'] % 2 ) ? ' thumbs-right' : '';
		?>
		<!-- ITEM -->
		<div class="col-lg-10 col-lg-offset-1">
			<div class="room_item-3<?php echo esc_attr( $class ); ?>">

				<div class="img">
					<a href="<?php echo esc_url( $link ); ?>">
						<?php echo get_the_post_thumbnail( $rt_id, 'engo-room-3' ); ?>
					</a>
				</div>

				<div class="text-thumbs">
					<?php if ( false != $thumb_second ) : ?>
						<div class="thumbs">
							<a href="<?php echo esc_url( $link ); ?>">
								<img src="<?php echo esc_url( $thumb_second[0] ); ?>" alt="<?php echo esc_html( get_the_title( $rt_id ) ); ?>">
							</a>
						</div>
					<?php endif; ?>

					<div class="text">
						<h2>
							<a href="<?php echo esc_url( $link ); ?>"><?php echo esc_html( get_the_title( $rt_id ) ); ?></a>
						</h2>
						<?php if ( ! empty( $data['start_price'] ) ) : ?>
							<span class="price">
								<?php
								printf( esc_html__( 'Start from %s per day', 'lotus' ), wp_kses_post( lotus_price( $data['start_price'] ) ) )
								?>
							</span>
						<?php endif; ?>
						<?php echo wp_kses_post( wpautop( get_post_meta( $rt_id, 'room_desc', true ) ) ); ?>
						<a href="<?php echo esc_url( $link ); ?>" class="engo-btn engo-btn-13"><?php esc_html_e( 'VIEW DETAILS', 'lotus' ); ?></a>
					</div>

				</div>

			</div>
		</div>
		<!-- END / ITEM -->
		<?php
	}
}

// Room Item 4.
if ( ! function_exists( 'lotus_room_item_4' ) ) {
	function lotus_room_item_4( $data ) {
		$rt_id        = isset( $data['rt_id'] ) ? $data['rt_id'] : 0;
		$link = get_permalink( $rt_id );
		$image2       = get_post_meta( $rt_id, '_feature_image_second', true );
		$thumb_second = wp_get_attachment_image_src( $image2, 'full' );
		if ( $rt_id == 0 ) {
			return;
		}
		$class = ( $data['i'] % 2 == 0 ) ? ' img-right' : '';
		?>
		<!-- ITEM -->
		<div class="room_item-4<?php echo esc_attr( $class ); ?>">

			<div class="img">
				<a href="<?php echo esc_url( $link ); ?>"><img src="<?php echo esc_url( $thumb_second[0] ); ?>" alt="<?php echo esc_attr( get_the_title( $rt_id ) ); ?>"></a>
			</div>

			<div class="text-thumbs">

				<div class="text">
					<h2><a href="<?php echo esc_url( $link ); ?>"><?php echo esc_html( get_the_title( $rt_id ) ); ?></a></h2>
					
					<?php if ( ! empty( $data['start_price'] ) ) : ?>
						<span class="price">
							<?php
							printf( esc_html__( 'Start from %s per day', 'lotus' ), wp_kses_post( lotus_price( $data['start_price'] ) ) )
							?>
						</span>
					<?php endif; ?>

					<?php echo wp_kses_post( wpautop( get_post_meta( $rt_id, 'room_desc', true ) ) ); ?>
					<a href="<?php echo esc_url( $link ); ?>"
					   class="engo-btn engo-btn-13"><?php esc_html_e( 'VIEW DETAILS', 'lotus' ); ?></a>
				</div>
				<div class="thumbs">
					<?php echo get_the_post_thumbnail( $rt_id, 'engo-room-slider' ); ?>
				</div>
			</div>
		</div>
		<!-- END / ITEM -->
		<?php
		wp_reset_postdata();
	}
}

// Room Item 5.
if ( ! function_exists( 'lotus_room_item_5' ) ) {
	function lotus_room_item_5( $data ) {
		$rt_id        = isset( $data['rt_id'] ) ? $data['rt_id'] : 0;
		$link = get_permalink( $rt_id );
		$image2       = get_post_meta( $rt_id, '_feature_image_second', true );
		$thumb_second = wp_get_attachment_image_src( $image2, 'engo-room-slider' );
		if ( $rt_id == 0 ) {
			return;
		}
		?>
		<!-- ITEM -->
		<div class="col-xs-6">
			<div class="room_item-5"
				 data-background='<?php $thumb = wp_get_attachment_image_src( get_post_thumbnail_id( $rt_id ), 'engo-room-slider' );
					echo esc_url( $thumb[0] ); ?>'>

				<div class="img">
					<a href="<?php echo esc_url( $link ); ?>"><?php echo get_the_post_thumbnail( $rt_id ); ?></a>
				</div>

				<div class="room_item-forward">
					<h2><a href="<?php echo esc_url( $link ); ?>"><?php echo esc_html( get_the_title( $rt_id ) ); ?></a></h2>
					<?php if ( ! empty( $data['start_price'] ) ) : ?>
						<span class="price">
							<?php
							printf( esc_html__( 'Starting %s/day', 'lotus' ), wp_kses_post( lotus_price( $data['start_price'] ) ) )
							?>
						</span>
					<?php endif; ?>
				</div>

				<div class="room_item-back">
					<h3><?php echo esc_html( get_the_title( $rt_id ) ); ?></h3>
					<?php if ( ! empty( $data['start_price'] ) ) : ?>
						<span class="price">
							<?php
							printf( esc_html__( 'Start from %s per day', 'lotus' ), wp_kses_post( lotus_price( $data['start_price'] ) ) )
							?>
						</span>
					<?php endif; ?>

					<?php echo wp_kses_post( wpautop( get_post_meta( $rt_id, 'room_desc', true ) ) ); ?>
					<a href="<?php echo esc_url( $link ); ?>" class="engo-btn engo-btn-13"><?php esc_html_e( 'VIEW DETAILS', 'lotus' ); ?></a>
				</div>

			</div>
		</div>
		<!-- END / ITEM -->
		<?php
	}
}

// Room Item 6.
if ( ! function_exists( 'lotus_room_item_6' ) ) {
	function lotus_room_item_6( $data ) {
		$rt_id        = isset( $data['rt_id'] ) ? $data['rt_id'] : 0;
		$link = get_permalink( $rt_id );
		$image2       = get_post_meta( $rt_id, '_feature_image_second', true );
		$thumb_second = wp_get_attachment_image_src( $image2, 'full' );
		if ( $rt_id == 0 ) {
			return;
		}
		$class = ( $data['i'] % 2 == 0 ) ? ' event' : '';
		?>
		<!-- ITEM -->
		<div class="room_item-6<?php echo esc_attr( $class ); ?>" data-background="<?php $thumb = wp_get_attachment_image_src( get_post_thumbnail_id( $rt_id ), 'full' ); echo esc_url( $thumb[0] ); ?>">

			<div class="text">
				<h2><a href="<?php echo esc_url( $link ); ?>"><?php echo esc_html( get_the_title( $rt_id ) ); ?></a></h2>
				<?php if ( ! empty( $data['start_price'] ) ) : ?>
					<span class="price">
						<?php
						printf( esc_html__( 'Starting %s/day', 'lotus' ), wp_kses_post( lotus_price( $data['start_price'] ) ) )
						?>
					</span>
				<?php endif; ?>
				<?php echo wp_kses_post( wpautop( get_post_meta( $rt_id, 'room_desc', true ) ) ); ?>
				<a href="<?php echo esc_url( $link ); ?>"
				   class="engo-btn engo-btn-13"><?php esc_html_e( 'VIEW DETAILS', 'lotus' ); ?></a>
			</div>

		</div>
		<!-- END / ITEM -->
		<?php
	}
}

// Room Item Slide 1
if ( ! function_exists( 'lotus_room_item_slide_1' ) ) {
	function lotus_room_item_slide_1( $data ) {
		$rt_id        = isset( $data['rt_id'] ) ? $data['rt_id'] : 0;
		$link = get_permalink( $rt_id );
		$image2       = get_post_meta( $rt_id, '_feature_image_second', true );
		$thumb_second = wp_get_attachment_image_src( $image2, 'full' );
		?>
		<!-- ITEM -->
		<div class="col-xs-4">
			<div class="accomd-modations-room">
				<div class="img">
					<a href="<?php echo esc_url( $link ); ?>"><?php echo get_the_post_thumbnail( $rt_id, 'engo-room-slider' ); ?></a>
				</div>
				<div class="text">
					<h2>
						<a href="<?php echo esc_url( $link ); ?>"><?php echo esc_html( get_the_title( $rt_id ) ); ?></a>
					</h2>

					<?php if ( ! empty( $data['start_price'] ) ) : ?>
						<p class="price">
							<?php printf( esc_html__( '%s/days', 'lotus' ), wp_kses_post( lotus_price( $data['start_price'] ) ) ); ?>
						</p>
					<?php endif; ?>
				</div>
			</div>
		</div>
		<!-- END / ITEM -->
		<?php
	}
}


// Room Item Slide 2
if ( ! function_exists( 'lotus_room_item_slide_2' ) ) {
	function lotus_room_item_slide_2( $data ) {
		$rt_id        = isset( $data['rt_id'] ) ? $data['rt_id'] : 0;
		$link = get_permalink( $rt_id );
		$image2       = get_post_meta( $rt_id, '_feature_image_second', true );
		$thumb_second = wp_get_attachment_image_src( $image2, 'full' );
		?>
		<!-- ITEM -->
		<div class="accomd-modations-room_1">
			<div class="img">
				<a href="<?php echo esc_url( $link ); ?>"><?php echo get_the_post_thumbnail( $rt_id , 'engo-room-slider' ); ?></a>
			</div>

			<div class="text">
				<h2><a href="<?php echo esc_url( $link ); ?>"><?php echo esc_html( get_the_title( $rt_id ) ); ?></a></h2>
				<div class="desc">
					<?php echo wp_kses_post( wpautop( get_post_meta( $rt_id, 'room_desc', true ) ) ); ?>
				</div>
				<div class="wrap-price">
				<?php if ( ! empty( $data['start_price'] ) ) : ?>

						<p class="price">
							<?php printf( esc_html__( '%s/days', 'lotus' ), wp_kses_post( lotus_price( $data['start_price'] ) ) ); ?>
						</p>

				<?php endif; ?>
				<a href="<?php echo esc_url( $link ); ?>" class="engo-btn engo-btn-default"><?php esc_html_e( 'VIEW DETAILS', 'lotus' ); ?></a>
				</div>
			</div>
		</div>
		<!-- END / ITEM -->
		<?php
	}
}
