<?php
if (class_exists('Vc_Manager')) :
    if (in_array('js_composer/js_composer.php', apply_filters('active_plugins', get_option('active_plugins')))) {
        function lotus_add_custum_shortcode_param($name, $form_field_callback, $script_url = null)
        {
            return WpbakeryShortcodeParams::addField($name, $form_field_callback, $script_url);
        }

        /**
         *
         * Lotus Custom Params
         * @package Visual Composer
         * @author Kai
         * @since 1.0.0
         * @return HTML
         */

        WpbakeryShortcodeParams::addField('social', 'engo_social_setting_field', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');
        function engo_social_setting_field($settings, $value)
        {
            parse_str(urldecode($value), $social_value);
            $socials = array(
                'facebook' => 'facebook',
                'google' => 'google-plus',
                'twitter' => 'twitter',
                'github' => 'github',
                'instagram' => 'instagram',
                'pinterest' => 'pinterest',
                'linkedin' => 'linkedin',
                'skype' => 'skype',
                'tumblr' => 'tumblr',
                'youtube' => 'youtube',
                'vimeo-square' => 'vimeo-square',
                'flickr' => 'flickr',
                'dribbble' => 'dribbble',
            );
            ob_start();
            ?>
            <style>
                .sc-social-icon a {
                    font-size: 12px;
                    display: inline-block;
                    border: 2px solid #898989;
                    color: #898989;
                    width: 24px;
                    height: 24px;
                    line-height: 22px;
                    margin: 0px 4px;
                    border-radius: 100%;
                    text-align: center;
                    transition: all 0.2s ease 0s;
                }
                .sc-social-icon .active {
                    border: 2px solid #2795D1;
                }
            </style>
            <div class="sc-social-icon">
                <?php foreach ($socials as $item) {
                    $current = (isset($social_value[$item])) ? $social_value[$item] : "";
                    $active = ($current!="") ? ' class="active"' : "" ;
                    echo '<a data-popup="' . esc_attr($item) . '" href="#"'.$active.'><i class="fa fa-' . esc_attr($item) . '"></i></a>';
                } ?>
            </div>
            <div class="sc-social-value">
                <?php foreach ($socials as $item) {
                    $current = (isset($social_value[$item])) ? $social_value[$item] : "";
                    echo '<p class="js-icon js-select-' . esc_attr($item) . ' hidden">';
                    echo '<label><strong>' . ucfirst($item) . '</strong></label>';
                    echo '<input type="text" class="wpb_vc_param_value wpb-textinput social-value" name="' . esc_attr($item) . '" value="'.esc_attr($current).'">';
                    echo '</p>';
                }
                ?>
            </div>
            <?php
            echo '<input name="' . esc_attr($settings['param_name']) . '" class="social-total-value wpb_vc_param_value wpb-textinput ' .
                esc_attr($settings['param_name']) . ' ' .
                esc_attr($settings['type']) . '_field" type="hidden" value="' . esc_attr($value) . '" />';
            $output = ob_get_clean(); // Get finally HTML to show
            return $output;
            ?>
        <?php
        }


        lotus_add_custum_shortcode_param('menu_drag_drop', 'engo_menu_drag_drop_field', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');

        function engo_menu_drag_drop_field($settings, $value)
        {
            $dependency = '';
            $li = $bvalue = '';
            $menu = new WP_Query(array('post_type' => $settings["post_type"], 'posts_per_page' => -1));
            if ($menu->have_posts()) {
                while ($menu->have_posts()) {
                    $menu->the_post();
                    $bvalue .= get_the_ID() . ',';
                }
	            wp_reset_postdata();
            }
            $sort = engo_merge_post_array($value, $bvalue);
            $value = '';
            foreach ($sort as $key) {
                if ($key != '') {
                    $li .= '<li data-id="' . $key . '">' . get_the_title($key) . '</li>';
                    $value .= $key . ',';
                }

            }

            $html = '<div class="menu-sort">';
            if ($li == '') {
                $html .= '<p>' . __('Please add post!', 'lotus') . '</p>';
            } else {
                $html .= '<ul class="engo-sortable">';
                $html .= $li;
                $html .= '</ul>';
            }
            $html .= '<input name="' . $settings['param_name'] . '" class="engo-sortable-value wpb_vc_param_value wpb-textinput ' . $settings['param_name'] . ' ' . $settings['type'] . '_field" type="hidden" value="' . $value . '" ' . $dependency . '>';
            $html .= '</div>';
            return $html;
        }

        // chose social icon and link
        lotus_add_custum_shortcode_param('social_upload', 'engo_vc_social', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');
        function engo_vc_social($settings, $value)
        {
            $dependency = '';
            $val = $value;
            $html = '<div class="engo_add_social">';

            parse_str(urldecode($value), $social);
            if (is_array($social)) {
                $i = 1;
                foreach ($social as $key => $value) {
                    $html .= '<div class="social-item" data-item="' . $i . '">';
                    $html .= '<input class="engo-input" name="' . $i . '[link]" value="' . $value['link'] . '" type="text" >';
                    $html .= '<span class="engo-change-icon"><i class="mdicon ' . $value['icon'] . '"></i>';
                    $html .= '<input class="engo-input" name="' . $i . '[icon]" value="' . $value['icon'] . '" type="hidden" >';
                    $html .= '</span>';
                    $html .= '<a href="#" class="engo-del-social">delete</a>';
                    $html .= '</div>';
                    $i++;
                }
            }
            $html .= '</div>';
            $html .= '<div class="engo-add"><button class="engo-button-add" type="button">' . __('Add social', 'lotus') . ' </button></div>';
            $html .= '<input name="' . $settings['param_name'] . '" class="engo-social-value wpb_vc_param_value wpb-textinput ' . $settings['param_name'] . ' ' . $settings['type'] . '_field" type="hidden" value="' . $val . '" ' . $dependency . '>';
            return $html;
        }

        lotus_add_custum_shortcode_param('engo_icon', 'engo_vc_icon', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');

        function engo_vc_icon($settings, $value)
        {
            if ($value == "") {
                $val = "fa fa-plus";
            } else {
                $val = $value;
            }
            return '<div class="my_param_block">'
            . '<span class="engo-change-icon"><i class="mdicon ' . $val . '"></i>'
            . '<input name="' . esc_attr($settings['param_name']) . '" class="engo-input wpb_vc_param_value wpb-textinput ' .
            esc_attr($settings['param_name']) . ' ' .
            esc_attr($settings['type']) . '_field" type="hidden" value="' . esc_attr($value) . '" />' .
            '</div>';
        }


        /*
         * Dev: Ha
         * Custom type shortcode
         */

        /*
         * Shortcode type load product
         */
        lotus_add_custum_shortcode_param('engo_load_product', 'engo_vc_load_product', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');

        function engo_vc_load_product($settings, $value)
        {
            $dependency = '';
            $val = $value;
            parse_str(urldecode($value), $data);
            $p = get_posts(array('post_type' => 'product', 'numberposts' => "9999"));

            ob_start();
            ?>
            <style>
                .select-product:hover {
                    color: blue;
                }

                .list-product {
                    border: 1px solid #ddd;
                    padding-left: 10px;
                }

                .tag-product {
                    padding-bottom: 5px;
                }

                .del-tag a {
                    color: white;
                    font-weight: bold;
                    text-decoration: none;
                }

                .engo-tag-product {
                    background: none repeat scroll 0 0 #00aef0;
                    border-radius: 5px;
                    color: white;
                    display: inline-block;
                    padding: 4px;
                    margin-right: 1px;
                    margin-top: 1px;
                }

                .check {
                    color: #dedede;
                    cursor: not-allowed;
                }

                .select-product {
                    cursor: pointer;
                }
            </style>
            <div class="edit_form_line">
                <div class="tag-product engoc_ct_mh50">
                    <?php
                    if (is_array($data)) {
                        $i = 1;
                        $j = 1;
                        foreach ($data as $key => $value) {
                            $ids[] = $value['post_id'];
                            $product = get_post($value['post_id']);
                            ?>
                            <div class="engo-tag-product" data-item="<?php echo intval($i++); ?>">
                                <span><?php echo esc_html($product->post_title); ?> </span>
                                <input class="engo-input" type="hidden"
                                       value="<?php echo esc_attr($value['post_id']); ?>"
                                       name="<?php echo sprintf('%s', $j++ . '[post_id]'); ?>">
                                <span class="del-tag" data-id="<?php echo esc_attr($value['post_id']); ?>"><a
                                        href="#"><i class="fa fa-trash"></i></a></span>
                            </div>
                        <?php
                        }
                    }
                    ?>
                </div>
                <div class="list-product engoc_ct_mh100">
                    <ul>
                        <?php foreach ($p as $item) {

                            echo '<li class="';
                            if (isset($ids)) {
                                if (in_array($item->ID, $ids)) {
                                    echo "check p-item" . absint($item->ID);
                                }
                            }
                            echo "select-product  p-item" . absint($item->ID);
                            echo '" data-id="' . absint($item->ID) . '">ID: ' . absint($item->ID) . " - " . esc_html($item->post_title) . '</li>';
                        } ?>
                    </ul>
                </div>
            </div>
            <input name="<?php echo esc_attr($settings['param_name']) ?>"
                   class="engo-type-value wpb_vc_param_value wpb-textinput <?php echo esc_attr($settings['param_name']) . "_" . esc_attr($settings['type']) ?>_field"
                   type="hidden" value="<?php echo esc_attr($val) . $dependency; ?>">
            <?php
            return ob_get_clean();
        }

        /*
         * end shortcode type load product
         */

        // field param
        lotus_add_custum_shortcode_param('engo_tab_slide', 'engo_vc_tab_slide', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');

        function engo_vc_tab_slide($settings, $value)
        {
            $dependency = '';
            $val = $value;
            parse_str(urldecode($value), $social);

            $html = '<div class="engo_add_tab_slide">';

            if (is_array($social)) {
                $i = 1;
                foreach ($social as $key => $value) {
                    $image = wp_get_attachment_image_src($value['image']);

                    $html .= '<div class="engo-call-item" data-item="' . $i . '">';
                    $html .= '<div class="vc_col-sm-12 vc_column wpb_el_type_attach_image vc_shortcode-param">
                                            <div class="wpb_element_label">Image</div>
                                            <div class="edit_form_line"><input type="hidden" value="' . $value['image'] . '"  name="' . $i . '[image]" class="engo-input wpb_vc_param_value gallery_widget_attached_images_ids image attach_image">
                                            <div class="gallery_widget_attached_images">
                                            <ul class="gallery_widget_attached_images_list ui-sortable">
                                           <li class="added">
                                               <div class="inner engoc-ct-inner">
                                                        <img src="' . esc_url($image[0]) . '" rel="126">
                                                           </div>
                                                           <a class="icon-remove" href="#"></a>
                                                   </li>
                                            </ul>
                                            </div>
                                            <div class="gallery_widget_site_images"></div>
                                            <a title="Add image" use-single="true" href="#" class="gallery_widget_add_images">Add image</a></div>
                                            </div>';
                    $html .= ' <div  class="vc_col-sm-12 vc_column wpb_el_type_textfield vc_shortcode-param">
                                                <div class="wpb_element_label">First text</div>
                                                <div class="edit_form_line"><input type="text" value="' . esc_attr($value['first']) . '" class="wpb_vc_param_value engo-input wpb-textinput"  name="' . $i . '[first]"></div>
                                             </div>';
                    $html .= '<div  class="vc_col-sm-12 vc_column wpb_el_type_textfield vc_shortcode-param">
                                                <div class="wpb_element_label">Last text</div>
                                                <div class="edit_form_line"><input type="text" value="' . esc_attr($value['last']) . '" class="wpb_vc_param_value engo-input wpb-textinput"  name="' . $i . '[last]"></div>
                                             </div>';

                    $html .= '<a href="#" class="engo-del-social">delete</a>';
                    $html .= '</div>';
                    $i++;
                }
            }
            $html .= '</div>';
            $html .= '<input type="button"  class="engo_add_tab button button-primary button-large" name="add" value="Add New">';
            $html .= '<input name="' . esc_attr($settings["param_name"]) . '" class="engo-social-value wpb_vc_param_value wpb-textinput ' . esc_attr($settings['param_name']) . ' ' . esc_attr($settings['type']) . '_field" type="hidden" value="' . esc_attr($val) . '" ' . $dependency . '>';
            return $html;

        }

        // field param
        lotus_add_custum_shortcode_param('add_text_field', 'engo_text_field', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');
        function engo_text_field($settings, $value)
        {
            $dependency = '';
            $val = $value;
            $html = '<div class="engo_add_field">';

            parse_str(urldecode($value), $field);
            if (is_array($field)) {
                $i = 1;
                foreach ($field as $key => $value) {
                    $html .= '<div class="field-item" data-item="' . $i . '">';
                    $html .= '<div class="wpb_element_label">' . __( 'Ingredient', 'lotus' ) . ' ' . $i . '</div>';
                    $html .= '<input class="engo-input engo-ingredient-save engo-ingredient" name="' . $i . '[ingredient]" value="' . $value['ingredient'] . '" type="text" >';
                    $html .= '<input class="engo-input engo-ingredient-save engo-detail" name="' . $i . '[detail]" value="' . $value['detail'] . '" type="text" >';
                    $html .= '<a href="#" class="engo-del-field">delete</a>';
                    $html .= '</div>';
                    $i++;
                }
            }
            $html .= '</div>';
            $html .= '<div class="add-field"><button class="engo-field-add" type="button">' . __('Add more', 'lotus') . ' </button></div>';
            $html .= '<input name="' . $settings['param_name'] . '" class="engo-field-value wpb_vc_param_value wpb-textinput ' . $settings['param_name'] . ' ' . $settings['type'] . '_field" type="hidden" value="' . $val . '" ' . $dependency . '>';
            return $html;
        }

        // location param

        lotus_add_custum_shortcode_param('add_location', 'engo_add_location', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');

        function engo_add_location($settings, $value)
        {
            $dependency = '';
            $val = $value;
            $html = '<div class="engo_add_location">';

            parse_str(urldecode($value), $locations);
            if (is_array($locations)) {
                $i = 1;
                foreach ($locations as $key => $value) {
                    $html .= '<div class="location-item" data-item="' . $i . '">';
                    $html .= '<div class="wpb_element_label">' . __("Location", 'lotus') . ' ' . $i . '</div>';
                    $html .= '<input class="engo-input engo-location-save engo-title" name="' . $i . '[title]" value="' . $value['title'] . '" type="text" >';
                    $html .= '<input class="engo-input engo-location-save engo-des" name="' . $i . '[des]" value="' . $value['des'] . '" type="text" >';
                    $html .= '<a href="#" class="engo-del-location">delete</a>';
                    $html .= '</div>';
                    $i++;
                }
            }
            $html .= '</div>';
            $html .= '<div class="add-location"><button class="engo-location-add" type="button">' . __('Add more', 'lotus') . ' </button></div>';
            $html .= '<input name="' . $settings['param_name'] . '" class="engo-location-value wpb_vc_param_value wpb-textinput ' . $settings['param_name'] . ' ' . $settings['type'] . '_field" type="hidden" value="' . $val . '" ' . $dependency . '>';
            return $html;
        }

        // Offer param

        lotus_add_custum_shortcode_param('add_offer', 'engo_add_offer', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');

        function engo_add_offer($settings, $value)
        {
            $dependency = '';
            $val = $value;
            $html = '<div class="engo_add_offer">';

            parse_str(urldecode($value), $offer);
            if (is_array($offer)) {
                $i = 1;
                foreach ($offer as $key => $value) {
                    $html .= '<div class="offer-item" data-item="' . $i . '">';
                    $html .= '<div class="wpb_element_label">' . __("Offer", 'lotus') . ' ' . $i . '</div>';
                    $html .= '<input class="engo-input engo-offer-save engo-offer" name="' . $i . '[offer]" value="' . $value['offer'] . '" type="text" >';
                    $html .= '<a href="#" class="engo-del-offer">delete</a>';
                    $html .= '</div>';
                    $i++;
                }
            }
            $html .= '</div>';
            $html .= '<div class="add-offer"><button class="engo-offer-add" type="button">' . __('Add more', 'lotus') . ' </button></div>';
            $html .= '<input name="' . $settings['param_name'] . '" class="engo-offer-value wpb_vc_param_value wpb-textinput ' . $settings['param_name'] . ' ' . $settings['type'] . '_field" type="hidden" value="' . $val . '" ' . $dependency . '>';
            return $html;
        }

        // Support Call param

        lotus_add_custum_shortcode_param('add_support_call', 'engo_add_support_call', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');

        function engo_add_support_call($settings, $value)
        {
            $dependency = '';
            $val = $value;
            $html = '<div class="engo_add_support_call">';

            parse_str(urldecode($value), $support);
            if (is_array($support)) {
                $i = 1;
                foreach ($support as $key => $value) {
                    $html .= '<div class="support-call-item" data-item="' . $i . '">';
                    $html .= '<div class="wpb_element_label">' . __("Support Call", 'lotus') . ' ' . $i . '</div>';
                    $html .= '<input class="engo-input engo-support-call-save engo-title" name="' . $i . '[title]" value="' . $value['title'] . '" type="text" >';
                    $html .= '<input class="engo-input engo-support-call-save engo-des" name="' . $i . '[des]" value="' . $value['des'] . '" type="text" >';
                    $html .= '<a href="#" class="engo-del-support-call">delete</a>';
                    $html .= '</div>';
                    $i++;
                }
            }
            $html .= '</div>';
            $html .= '<div class="add-support-call"><button class="engo-support-call-add" type="button">' . __('Add more', 'lotus') . ' </button></div>';
            $html .= '<input name="' . $settings['param_name'] . '" class="engo-support-call-value wpb_vc_param_value wpb-textinput ' . $settings['param_name'] . ' ' . $settings['type'] . '_field" type="hidden" value="' . $val . '" ' . $dependency . '>';
            return $html;
        }

        // one field param

        lotus_add_custum_shortcode_param('add_tips_field', 'engo_tips_field', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');

        function engo_tips_field($settings, $value)
        {
            $dependency = '';
            $val = $value;
            $html = '<div class="engo_add_step">';

            parse_str(urldecode($value), $steps);
            if (is_array($steps)) {
                $i = 1;
                foreach ($steps as $key => $value) {
                    $html .= '<div class="step-item" data-item="' . $i . '">';
                    $html .= '<div class="wpb_element_label">' . __( 'Step', 'lotus' ) . ' ' . $i . '</div>';
                    $html .= '<input class="engo-input engo-step-save" name="' . $i . '[step]" value="' . $value['step'] . '" type="text" >';
                    $html .= '<a href="#" class="engo-del-step">delete</a>';
                    $html .= '</div>';
                    $i++;
                }
            }
            $html .= '</div>';
            $html .= '<div class="add-step"><button class="engo-step-add" type="button">' . __('Add more', 'lotus') . ' </button></div>';
            $html .= '<input name="' . $settings['param_name'] . '" class="engo-step-value wpb_vc_param_value wpb-textinput ' . $settings['param_name'] . ' ' . $settings['type'] . '_field" type="hidden" value="' . $val . '" ' . $dependency . '>';
            return $html;
        }

        lotus_add_custum_shortcode_param('engo_sort_cat', 'engo_sort_cat', get_template_directory_uri() . '/engo_shortcode/assets/js/vc_js.js');

        function engo_sort_cat($settings, $value)
        {
            global $bvalue;
            $dependency = '';
            $li = '';
            $sort = engo_merge_array($value, $bvalue, $settings['cat_type']);
            $value = '';
            foreach ($sort as $key) {
                if ($key != '') {
                    $value .= $key . ',';
                    $cat = get_term($key, $settings['cat_type']);
                    if (is_object($cat)) {
                        $li .= '<li data-id="' . $key . '">' . esc_attr($cat->name) . '</li>';
                    }
                }
            }

            $html = '<div class="menu-sort">';
            if ($li == '') {
                $html .= '<p>' . __('Please add Product Category!', 'lotus') . '</p>';
            } else {
                $html .= '<ul class="engo-sortable">';
                $html .= $li;
                $html .= '</ul>';
            }
            $html .= '<input name="' . $settings['param_name'] . '" class="engo-sortable-value wpb_vc_param_value wpb-textinput ' . $settings['param_name'] . ' ' . $settings['type'] . '_field" type="hidden" value="' . $value . '" ' . $dependency . '>';
            $html .= '</div>';
            return $html;
        }


        function engo_merge_array($str_1, $str_2, $type)
        {
            $array_1 = explode(',', $str_1);
            $array_2 = explode(',', $str_2);
            $array = array();
            foreach ($array_1 as $value) {
                if ($value != '') {
                    $terms = get_term($value, $type);
                    if (is_object($terms)) {
                        if ($terms->count >= 1) {
                            array_push($array, $terms->term_id);
                        }
                    }
                }
            }
            if (count($array) <= count($array_2)) {
                foreach ($array_2 as $value) {
                    if (!in_array($value, $array)) {
                        array_unshift($array, $value);
                    }
                }
            }
            return $array;
        }

        function engo_merge_post_array($str_1, $str_2)
        {
            $array_1 = explode(',', $str_1);
            $array = array();
            foreach ($array_1 as $key) {
                if ($key != '') {
                    if (get_post_status($key) == 'publish') {
                        array_push($array, $key);
                    }
                }
            }
            $array_2 = explode(',', $str_2);
            if (count($array) <= count($array_2)) {
                foreach ($array_2 as $value) {
                    if (!in_array($value, $array)) {
                        array_unshift($array, $value);
                    }
                }
            }
            return $array;
        }


    }
endif;