<?php

if ( !defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly



WpbakeryShortcodeParams::addField( 'param_testimonial', 'engo_testimonial_field', get_template_directory_uri() . '/engo_shortcode/assets/js/params.js' );

function engo_testimonial_field( $settings, $value ) {


	$dependency = '';
	$meta_id = absint( $value );
	$li = '';
	$hide_addnew = '';
	if ( $meta_id > 0 ) {

		global $wpdb;
		$result = $wpdb->get_var( $wpdb->prepare( "SELECT `meta_value` FROM $wpdb->postmeta WHERE meta_id = %d", absint( $meta_id ) ) );



		parse_str( trim($result), $list );
		// var_dump($list);
		$list_size = count( $list );
		if ( trim( $result ) != "" && is_array( $list ) && $list_size > 0 ) {
			$count = 0;
			foreach ( $list as $item ) {
				$count++;


				/*
				 * @Value
				 */
				$image = isset( $item['image'] ) ?  $item['image'] : '';
				$customer = isset( $item['customer'] ) ? esc_html( $item['customer'] ) : '';
				$position = isset( $item['position'] ) ? esc_html( $item['position'] ) : '';
				$content = isset( $item['content'] ) ? esc_textarea( $item['content'] ) : '';
				// $content = isset( $item['content'] ) ? esc_html( $item['content'] ) : '';

				$subject = isset( $item['subject'] ) ? esc_html( $item['subject'] ) : '';


				/*
				 * @Image
				 */
				$image_arr = wp_get_attachment_image_src( $image, 'thumbnail' );
				$background = ($image == '') ? '' : "style='background:url({$image_arr[0]})'";
				$has_thumb = ($image == '') ? '' : 'has-thumb';

				/*
				 * @Head title
				 */
				$head_name = ($customer  == '') ? "Customer {$customer} {$count}" : $item['customer'];

				/*
				 * @Render html
				 */
				$li .= "<li data-id='{$count}'>
				<div class='widget'>
					<div class='widget-top'>
					<div class='widget-title-action'>
						<a class='cmd cmd-edit' title='Edit'><i class='fa fa-pencil'></i></a>
						<a class='cmd cmd-copy' title='Copy'><i class='fa fa-files-o'></i></a>
						<a class='cmd cmd-remove' title='Remove'><i class='fa fa-trash-o'></i></a>
					</div>
					<div class='widget-title ui-sortable-handle'><h4 class='cmd-edit'>{$head_name}</h4></div>
					</div>
					<div class='widget-inside'>
						<table>
							<tr>
								<td>
									<a href='#' class='thumbnail engo-thumbnail {$has_thumb}' {$background}><span>Edit</span></a>
									<input class='image vc_input' type='hidden' name='{$count}[image]' value='{$image}'/>
								</td>
								<td>
									<input class='subject vc_input small' name='{$count}[subject]' type='text' placeholder='Subject' value='{$subject}'>
									<input class='customer vc_input small' name='{$count}[customer]' type='text' placeholder='Customer name' value='{$customer}'>
									<input class='position vc_input small' name='{$count}[position]' type='text' placeholder='Location' value='{$position}'>
									<textarea class='content vc_input' name='{$count}[content]' placeholder='Feedback content'>{$content}</textarea>
								</td>
							</tr>
						</table>
					</div>
				</div>
			</li>";
			}
		} else {
			$hide_addnew = 'hide';
			$li = "<li class='empty'>" . __( 'List is empty', 'lotus' ) . "<a href='#' class='new-item'>" . __( 'Add item', 'lotus' ) . "</a></li>";
		}
	} else {
		$hide_addnew = 'hide';
		$li = "<li class='empty'>" . __( 'List is empty', 'lotus' ) . "<a href='#' class='new-item'>" . __( 'Add item', 'lotus' ) . "</a></li>";
	}
	$param_name = esc_attr( $settings["param_name"] );
	$type = esc_attr( $settings['type'] );

	return "<div class='Engo_param testimonial engo_param_field saveajax' data-meta_key='testimonial'>
				<ul>{$li}</ul>
				<a href='#' class='new-bottom new-item {$hide_addnew}'><i class='fa fa-plus'></i>Add item</a>
				<input name='{$param_name}' class='Engo_param_hidden wpb_vc_param_value wpb-textinput {$param_name}  {$type}_field' type='hidden' value='{$meta_id}' {$dependency} />
		   </div>"; // New button element
}





?>
