<?php

class ENGO_Button_Alert extends engo_shortcode {

	public function __construct() {
		$this->custom_shortcode( 'engo_alert', array( $this, 'engo_render_html' ) );
		add_action( 'vc_before_init', array( $this, 'engo_vc_shortcode' ) );
	}


	public function engo_vc_shortcode() {
		vc_map( array(
			'name'	=> __( 'Engo Alert', 'lotus' ),
			'base'	=> 'engo_alert',
			'category'	=> __( 'Engo shortcode', 'lotus' ),
			'icon'	=> $this->icon('shortcode.png'),
            'description' => __( 'Display alert info.', 'lotus' ),
			'params'	=> array(
				array(
					'type'	=> 'textarea',
					'heading'	=> __( 'Alert text', 'lotus' ),
					'param_name'	=> 'alert_content',
					// 'holder'	=> 'div',
				),
				array(
					'type'	=> 'dropdown',
					'heading'	=> __( 'Alert type', 'lotus' ),
					'param_name'	=> 'type',
					'value'	=> array(
						__( 'Success', 'lotus' )	=> 'success',
						__( 'Info', 'lotus' )	=> 'info',
						__( 'Warning', 'lotus' )		=> 'warning',
						__( 'Danger', 'lotus' )	=> 'danger',
					),
				),
			)
		) );
	}


	public function engo_render_html( $atts, $content = '' ) {
		extract( shortcode_atts( array( 'type' => 'success','alert_content' => '' ), $atts ) );
		$output = '';
		if ( $alert_content ) {
			$output = '<p class="alert alert-' . esc_attr( $type ) . '">' . esc_textarea( $alert_content ) . '</p>';
		}

		return $output;
	}

}


if ( class_exists( 'WPBakeryShortCode' ) ) {

	class WPBakeryShortCode_ENGO_Alert extends WPBakeryShortCode {

	}

}
