<?php

class engo_lotus_animate_number extends engo_shortcode {
	public function __construct() {
		$this->custom_shortcode( 'engo_lotus_animate_number', array( $this, 'engo_render_html' ) );
		add_action( 'vc_before_init', array( $this, 'engo_vc_shortcode' ) );
	}

	public function engo_vc_shortcode() {
		vc_map( array(
			"name"                    => __( "Engo Animate Number", 'lotus' ),
			"base"                    => "engo_lotus_animate_number",
			"content_element"         => true,
			"wrapper_class"           => "",
			"class"                   => "engo_shortcode",
			"show_settings_on_create" => true,
			"category"                => __( "Engo shortcode", 'lotus' ),
			"icon"                    => $this->icon( 'shortcode.png' ),
			'description' 			  => __( 'Transform of number.', 'lotus' ),
			"params"                  => array(
				array(
					"type"       => "textfield",
					"heading"    => __( "Heading Text", 'lotus' ),
					"param_name" => "text",
					"value"      => __( "Guest Stay", 'lotus' ),
				),
				array(
					"type"       => "textfield",
					"heading"    => __( "Number", 'lotus' ),
					"param_name" => "number",
					"value"      => 768
				)
			),
		) );
	}

	public function engo_render_html( $atts, $content = '' ) {

		extract( shortcode_atts( array(
			'number' => '',
			'text'	=> '',
		), $atts ) );
		ob_start();
		?>
		<div class="statistics_item">
			<span class="count"><?php print $number; ?></span>
			<?php if ( $text ) echo '<span>' . esc_html( $text ) . '</span>'; ?>
		</div>
		<?php
		return ob_get_clean();
	}
}

if ( class_exists( 'WPBakeryShortCode' ) ) {
	class WPBakeryShortCode_engo_lotus_animate_number extends WPBakeryShortCode {
	}
}
