<?php

if ( class_exists( 'AWE_function' ) ) {


	class ENGO_Check_Available_Form_Shortcode extends engo_shortcode {

		public function __construct() {
			$this->custom_shortcode( 'engo_check_available_form', array( $this, 'engo_render_html' ) );
			add_action( 'vc_before_init', array( $this, 'engo_vc_shortcode' ) );
		}

		public function engo_vc_shortcode() {
			vc_map( array(
				'name'	=> __( 'Engo Check Available Form', 'lotus' ),
				'base'	=> 'engo_check_available_form',
				'class'	=> '',
				'category'	=> __( 'Engo shortcode', 'lotus' ),
				'icon'	=> $this->icon( 'shortcode.png' ),
	            'description' => __( 'Display check available form', 'lotus' ),
				'params'	=> array(
					array(
						'type'	=> 'dropdown',
						'heading'	=> __( 'Enable Departure Date', 'lotus' ),
						'param_name'	=> 'to',
						'value'	=> array(
							__( 'Yes', 'lotus' )	=> 'yes',
							__( 'No', 'lotus' )	=> 'no',
						),
					),
					array(
						'type'	=> 'dropdown',
						'heading'	=> __( 'Enable Night Number', 'lotus' ),
						'param_name'	=> 'night',
						'value'	=> array(
							__( 'Yes', 'lotus' )	=> 'yes',
							__( 'No', 'lotus' )	=> 'no',
						),
					),
					array(
						'type'	=> 'dropdown',
						'heading'	=> __( 'Form layout', 'lotus' ),
						'param_name'	=> 'layout',
						'value'	=> array(
							__( 'Vertical', 'lotus' )	=> 'vertical',
							__( 'Horizontal', 'lotus' )	=> 'horizontal',
						),
					),

					array(
						'type'	=> 'dropdown',
						'heading'	=> __( 'Form style', 'lotus' ),
						'param_name'	=> 'style',
						'value'	=> array(
							__( 'Default', 'lotus' )	=> 'default',
							__( 'Custom Lotus', 'lotus' )	=> 'custom',
						),
					),
				),
			) );
		}

		public function engo_render_html( $atts, $content = '' ) {
			extract( shortcode_atts( array(
				'to'	=> 'yes',
				'night'	=> 'yes',
				'layout'	=> 'vertical',
				'style'	=> 'default',
			), $atts ) );

			ob_start();


			do_action( 'apb_get_day_advance' );
			?>
			<div class="engobooking-wrapper <?php echo 'horizontal' == $layout ? 'inline' : ''; ?> <?php echo "custom" == $style ? 'custom-lotus' : '';?>">

				<!-- SIDEBAR CONTENT -->
				<div class="apb-content">
					<form method="get" action="<?php echo esc_url( AWE_function::get_check_available_page() ); ?>" class="apb-single-check-avb-form">

						<div class="apb-field">
							<label><?php esc_html_e( 'Arrival Date', 'lotus' ); ?></label>

							<div class="apb-field-group">
								<i class="apbf apbf-calendar"></i>
								<?php
								/**
								 * General input from date
								 */
								AWE_function::apb_gen_input( array(
									'type'          => 'text',
									'name'          => 'from',
									'placeholder'   => esc_attr__( 'Arrival Date', 'lotus' ),
									'class'         => 'date-start-js apb-calendar apb-input',
								) );
								?>
							</div>
						</div>

						<?php if ( 'yes' == $night ) { ?>
							<div class="apb-field <?php echo 'horizontal' == $layout ? 'small' : ''; ?>">
								<label><?php esc_html_e( 'Nights', 'lotus' ); ?></label>
								<div class="apb-field-group">
									<i class="apbf apbf-select"></i>
									<?php
									/**
									 * General selected total numner of night
									 */
									AWE_function::apb_get_option_to_selected( array(
										'default' => array(
											'label' => esc_attr__('Nights', 'lotus'),
											'value' => ''
										),
										'name' => '',
										'count_num' => get_option( 'max_night' ),
										'data' => array(
											'class' => 'apb-select night-select-js',
										),
									) );
									?>
								</div>
							</div>
						<?php } ?>


						<?php
						if ( 'yes' == $to ) {
							?>
							<div class="apb-field">
								<label><?php esc_html_e( 'Departure Date', 'lotus' ); ?></label>
								<div class="apb-field-group">
									<i class="apbf apbf-calendar"></i>
									<?php
									/**
									 * General input to date
									 */
									AWE_function::apb_gen_input( array(
										'type'          => 'text',
										'name'          => 'to',
										'placeholder'   => esc_attr__( 'Departure Date', 'lotus' ),
										'class'         => 'date-end-js apb-calendar apb-input',
									) );
									?>
								</div>
							</div>
							<?php
						} else {
							echo '<input type="hidden" name="to" class="date-end-js">';
						}

						/*----------  Disnable/Enable div html by style.  ----------*/
						?>
						<div class="apb-field <?php echo 'horizontal' == $layout ? 'small' : ''; ?>">
							<label><?php esc_html_e( 'Adult', 'lotus' ); ?></label>
							<div class="apb-field-group">
								<i class="apbf apbf-select"></i>
								<?php
								/**
								 * General selected number of maximum adult
								 */
								AWE_function::apb_get_option_to_selected( array(
									'default' => array(
										'label' => esc_attr__('Adult', 'lotus'),
										'value' => ''
									),
									'name' => 'room_adult[]',
									'count_num' => get_option( 'max_adult' ),
									'data' => array(
										'class' => 'apb-select apb-adult-select',
									),
								) );
								?>
							</div>
						</div>
						<div class="apb-field <?php echo 'horizontal' == $layout ? 'small' : ''; ?>">
							<label><?php esc_html_e( 'Children', 'lotus' ); ?></label>

							<div class="apb-field-group">
								<i class="apbf apbf-select"></i>
								<?php
								/**
								 * General selected number of maximum child
								 */
								AWE_function::apb_get_option_to_selected( array(
									'default' => array(
										'label' => esc_attr__('Children', 'lotus'),
										'value' => ''
									),
									'name' => 'room_child[]',
									'start_num' => 0,
									'count_num' => get_option( 'max_child' ),
									'data' => array(
										'class' => 'apb-select apb-child-select',
									),
								) );
								?>
							</div>
						</div>
						<button type="submit" class="apb-btn engo-btn-13"><?php esc_html_e( 'FIND THE BEST RATE', 'lotus' ); ?></button>

						<input type="hidden" value="<?php echo absint( get_option( 'max_night' ) ); ?>" class="max-night-js">
						<input type="hidden" name="check_from" value="shortcode">

						<?php
						if ( defined( 'ICL_SITEPRESS_VERSION' ) ) {
							echo '<input type="hidden" name="lang" value="' . ICL_LANGUAGE_CODE . '">';
						}
						?>
					</form>
				</div>
				<!-- END / SIDEBAR CONTENT -->

			</div>
			<?php

			return ob_get_clean();

		}

	}

	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_ENGO_Reservation_Form extends WPBakeryShortCode {

		}
	}

}
