<?php

class ENGO_Event_Shortcode extends engo_shortcode {

	public function __construct() {
		$this->custom_shortcode( 'engo_event', array( $this, 'engo_render_html' ) );
		add_action( 'vc_before_init', array( $this, 'engo_vc_shortcode' ) );
	}


	public function engo_vc_shortcode() {
		$style = array( 1, 2);
		vc_map( array(
			'name'	=> __( 'Engo Event', 'lotus' ),
			'description'	=> __( 'Display new events', 'lotus' ),
			'base'	=> 'engo_event',
			'class'	=> '',
			'category'	=> __( 'Engo shortcode', 'lotus' ),
			'icon'	=> $this->icon( 'shortcode.png' ),
			'params'	=> array(
				array(
					'type'       => 'dropdown',
					'heading'    => __( 'Style', 'lotus' ),
					'param_name' => 'style',
					'value'      => $style,
					'description' => 'Select a style',
				),
				array(
					'type'	=> 'textfield',
					'heading'	=> __( 'Event Number', 'lotus' ),
					'param_name'	=> 'num',
					'description'	=> __( 'Number of events to show', 'lotus' ),
					'std'	=> 3,
				),
			),
		) );
	}


	public function engo_render_html( $atts, $content = '' ) {
		$atts = shortcode_atts( array( 'num' => 3, 'style' => '' ), $atts );
		$the_query = new WP_Query( 'post_type=event&posts_per_page=' . absint( $atts['num'] ) );

		if ( ! $the_query->have_posts() ) {
			return '<p>' . __( 'No event found.', 'lotus' ) . '</p>';
		}
		$style = $atts['style']?$atts['style']:1;
		ob_start();

		if ( $style == 1 ) {
		?>
			<div class="row">
				<?php while ( $the_query->have_posts() ) : $the_query->the_post(); ?>
					<?php
					$date = get_post_meta( get_the_ID(), 'engo_event_metabox_date', true ) ? strtotime( get_post_meta( get_the_ID(), 'engo_event_metabox_date', true ) ) : '';
					$time = get_post_meta( get_the_ID(), 'engo_event_metabox_time', true ) ? esc_html( get_post_meta( get_the_ID(), 'engo_event_metabox_time', true ) ) : '';
					?>
					<div class="col-xs-6">
						<div class="event-item">
							<div class="img">
								<a class="hover-zoom" href="<?php the_permalink(); ?>">
									<?php echo get_the_post_thumbnail( get_the_ID(), 'engo-post-sc' ); ?>
								</a>
							</div>
							<div class="text">
								<div class="text-cn">
									<h2><?php the_title(); ?></h2>
									<span><?php echo date_i18n( 'd', $date ); ?> <?php echo strtoupper( date_i18n( 'M', $date ) ); ?></span>
									<a href="<?php the_permalink(); ?>" class="engo-btn engo-btn-12"><?php _e('VIEW MORE', 'lotus');?></a>
								</div>
							</div>
						</div>
					</div>
				<?php endwhile; wp_reset_postdata(); ?>
			</div>
		<?php
		} elseif ($style == 2) {
			?>
			<ul class="event-restaurant_content">
				<?php while ( $the_query->have_posts() ) : $the_query->the_post(); ?>
					<?php
					$date = get_post_meta( get_the_ID(), 'engo_event_metabox_date', true ) ? strtotime( get_post_meta( get_the_ID(), 'engo_event_metabox_date', true ) ) : '';
					$time = get_post_meta( get_the_ID(), 'engo_event_metabox_time', true ) ? esc_html( get_post_meta( get_the_ID(), 'engo_event_metabox_time', true ) ) : '';
					?>
	                <li>
	                	<?php if ( $date ) : ?>
		                    <span class="event-date">
		                        <strong><?php echo date_i18n( 'd', $date ); ?></strong>
		                        <?php echo strtoupper( date_i18n( 'M', $date ) ); ?>
		                    </span>
		                <?php endif; ?>
	                    <div class="text">
	                        <h2><?php the_title(); ?></h2>
	                        <a href="<?php the_permalink(); ?>"><?php _e( '[ Read More ]', 'lotus' ); ?></a>
	                    </div>
	                </li>
	            <?php endwhile; wp_reset_postdata(); ?>
            </ul>
			<?php
				}
			?>
		<?php
		$output = ob_get_clean();
		return $output;
	}

}

if ( class_exists( 'WPBakeryShortCode' ) ) {
	class WPBakeryShortCode_ENGO_Event_Shortcode extends WPBakeryShortCode {

	}
}
