<?php
/**
 * Engo gmap shortcode
 *
 * @package Lotus
 */

/**
 * Class Engo_gmap
 */
class Engo_gmap extends Engo_shortcode {

	public function __construct() {
		$this->custom_shortcode( 'engo_gmap', array( $this, 'engo_render_html' ) );
		add_action( 'vc_before_init', array( $this, 'engo_vc_shortcode' ) );
	}

	public function engo_vc_shortcode() {
		vc_map( array(
			'name' => __( 'Engo Google map', 'lotus' ),
			'base' => 'engo_gmap',
			'content_element' => true,
			'wrapper_class' => '',
			'class' => 'engo_shortcode',
			'show_settings_on_create' => true,
			'category' => __( 'Engo shortcode', 'lotus' ),
			'admin_enqueue_js' => array(
				'http://maps.google.com/maps/api/js?libraries=places&key=AIzaSyAmVMX4ea-eLWvfu-AReW4SO_b1pO2LA2k',
				$this->get_resource( 'google/jquery.geocomplete.js', 'vendors' ),
			),
			'front_enqueue_js' => array(
				'http://maps.google.com/maps/api/js?libraries=places',
				$this->get_resource( 'google/jquery.geocomplete.js', 'vendors' ),
			),
			'icon' => $this->icon(),
			'description' => __( 'Display google map.', 'lotus' ),
			'params' => array(
				array(
					'type' => 'engo_param_gmap',
					'class' => '',
					'heading' => __( 'Search map', 'lotus' ),
					'param_name' => 'mapinfo',
					'value' => '',
				),
			),
			'deprecated' => '1.11',
		) );
	}

	public function engo_render_html( $atts, $content = '' ) {
		$map = array(
			'location' => '',
			'latlong'  => '',
			'zoom'     => '',
		);

		if ( ! empty( $atts['mapinfo'] ) && 'EMPTY' != $atts['mapinfo'] ) {
			parse_str( urldecode( $atts['mapinfo'] ), $mapdata );
			$map = array_merge( $map, $mapdata );
		}

		if ( '' != $map['latlong'] ) {
			$latlong = explode( ',', $map['latlong'] );
		} else {
			$latlong = array( '', '' );
		}


		wp_enqueue_script( 'google-map-api', 'http://maps.google.com/maps/api/js?key=AIzaSyAmVMX4ea-eLWvfu-AReW4SO_b1pO2LA2k', array(), null );
		wp_enqueue_script( 'gmap', $this->get_resource( 'google/gmaps.min.js', 'vendors' ), 'google-map-api', '0.4.15', true );
		wp_enqueue_script( 'engo-js-gmap', get_template_directory_uri() . '/engo_shortcode/assets/js/gmap_script.js', array( 'jquery' ), false, true );

		return '<div class="Engo_gmap contact-map" id="Engo_gmap_' . $this->getId() . '" data-zoom="' . esc_attr( $map['zoom'] ) . '" data-lat="' . esc_attr( $latlong[0] ) . '" data-lng="' . esc_attr( $latlong[1] ) . '"></div>';
	}
}

if ( class_exists( 'WPBakeryShortCode' ) ) {

	class WPBakeryShortCode_Engo_gmap extends WPBakeryShortCode {

	}
}
