<?php

class ENGO_Iconlist extends engo_shortcode {

	public function __construct() {
		$this->custom_shortcode( 'engo_iconlist', array( $this, 'engo_render_html' ) );
		add_action( 'vc_before_init', array( $this, 'engo_vc_shortcode' ) );
	}

	public function engo_vc_shortcode() {
		vc_map( array(
			'name' => __( 'Engo Iconlist', 'lotus' ),
			'base' => 'engo_iconlist',
			'category' => __( 'Engo shortcode', 'lotus' ),
			'icon' => $this->icon( 'shortcode.png' ),
			'class' => 'engo_shortcode',
			'admin_enqueue_css' => array(
				get_template_directory_uri() . '/engo_shortcode/assets/css/engo_style.css',
				get_template_directory_uri() . '/Framework/asset/icons/css/lotusicon.css',
				get_template_directory_uri() . '/engo_shortcode/assets/iconlist/engo-dialog.css',
			),
			'front_enqueue_css' => get_template_directory_uri() . '/engo_shortcode/assets/css/engo_style.css',
			'description' => __( 'Display icon list', 'lotus' ),
			'params' => array(
				array(
					'type'       => 'param_iconlist',
					'heading'    => __( '', 'lotus' ),
					'class'      => 'Engo_meta_id',
					'holder'     => 'div',
					'param_name' => 'list',
					'value'      => '',
				),
			),
			'deprecated' => '1.10',
		) );
	}

	public function engo_render_html( $atts, $content = '' ) {
		extract( shortcode_atts( array(
			'list' => '',
		), $atts ) );

		global $wpdb;

		$result = $wpdb->get_var( $wpdb->prepare( "SELECT `meta_value` FROM $wpdb->postmeta WHERE meta_id = %d", absint( $list ) ) );

		parse_str( trim($result), $arr );


		ob_start();
		if ( count( $arr ) > 0 ) {
			?>

				<div class="engo-icon-list">
					<ul>
						<?php foreach ( $arr as $v ) : ?>
							<li>
								<?php if ( ! empty( $v['icon'] ) ) : ?>
									<i class="iconlist-icon <?php echo esc_attr( $v['icon'] ); ?>"></i>
								<?php endif; ?>

								<?php if ( ! empty( $v['text'] ) ) : ?>
									<span class="iconlist-title"><?php echo esc_html( $v['text'] ); ?></span>
								<?php endif; ?>
							</li>
						<?php endforeach; ?>
					</ul>
				</div>

			<?php
		} else {
			echo esc_html__( 'There\'s no list item', 'lotus' );
		}
		$output = ob_get_clean();
		// Return output
		return $output;
	}

}

if ( class_exists( 'WPBakeryShortCode' ) ) {

	class WPBakeryShortCode_ENGO_Iconlist extends WPBakeryShortCode {

	}


}


