<?php
/**
 * Engo iconlist 2 shortcode
 *
 * @package Lotus
 */

/**
 * Class ENGO_Iconlist2
 */
class ENGO_Iconlist2 extends engo_shortcode {

	/**
	 * Shortcode name.
	 *
	 * @var string
	 * @access protected
	 */
	protected $shortcode_name = 'engo_iconlist2';


	/**
	 * Constructor.
	 */
	public function __construct() {
		$this->custom_shortcode( $this->shortcode_name, array( $this, 'engo_render_html' ) );
		add_action( 'vc_before_init', array( $this, 'engo_vc_shortcode' ) );
	}


	/**
	 * Map shortcode with VC.
	 */
	public function engo_vc_shortcode() {
		vc_map( array(
			'name' => __( 'Engo Iconlist 2', 'lotus' ),
			'base' => $this->shortcode_name,
			'category' => __( 'Engo shortcode', 'lotus' ),
			'icon' => $this->icon( 'shortcode.png' ),
			'class' => 'engo_shortcode',
			'description' => __( 'Display icon list', 'lotus' ),
			'params' => array(
				array(
					'type'       => 'param_group',
					'heading'    => __( 'Icons list', 'lotus' ),
					'param_name' => 'icons',
					'params'     => array(
						array(
							'type'       => 'iconpicker',
							'heading'    => __( 'Choose icon', 'lotus' ),
							'param_name' => 'icon',
							'value'      => 'fa fa-adjust',
							'settings'   => array(
								'emptyIcon'    => '',
								'iconsPerPage' => 4000,
							),
						),
						array(
							'type'       => 'textfield',
							'heading'    => __( 'Icon text', 'lotus' ),
							'param_name' => 'text',
						),
					),
				),
			),
		) );
	}


	/**
	 * Shortcode output.
	 *
	 * @param  array  $atts    Attributes.
	 * @param  string $content Content.
	 * @return string
	 */
	public function engo_render_html( $atts, $content = '' ) {
		$atts = shortcode_atts( array(
			'icons' => '',
		), $atts );

		$icons = vc_param_group_parse_atts( $atts['icons'] );

		if ( empty( $icons ) ) {
			return;
		}

		wp_enqueue_style( 'font-awesome' );

		ob_start();
		?>
		<div class="engo-icon-list">
			<ul>
				<?php foreach ( $icons as $v ) : ?>
					<li>
						<?php if ( ! empty( $v['icon'] ) ) : ?>
							<i class="iconlist-icon <?php echo esc_attr( $v['icon'] ); ?>"></i>
						<?php endif; ?>

						<?php if ( ! empty( $v['text'] ) ) : ?>
							<span class="iconlist-title"><?php echo esc_html( $v['text'] ); ?></span>
						<?php endif; ?>
					</li>
				<?php endforeach; ?>
			</ul>
		</div>
		<?php
		return ob_get_clean();
	}
}

if ( class_exists( 'WPBakeryShortCode' ) ) {

	class WPBakeryShortCode_ENGO_Iconlist2 extends WPBakeryShortCode {

	}
}
