<?php

class engo_lotus_team extends engo_shortcode
{

    public function __construct()
    {
        $this->custom_shortcode('engo_lotus_team', array($this, 'engo_render_html'));
        add_action('vc_before_init', array($this, 'engo_vc_shortcode'));
    }

    public function engo_vc_shortcode()
    {
        vc_map(array(
            'name' => __('Engo Team', 'lotus'),
            'base' => 'engo_lotus_team',
            "category" => __("Engo shortcode", 'lotus'),
            "icon" => $this->icon('shortcode.png'),
            'description' => __('Display team members', 'lotus'),
            "class" => "engo_shortcode",
            'params' => array(
                array(
                    "type" => "textfield",
                    "heading" => __("Team Member Name", 'lotus'),
                    "param_name" => "name",
                    'description'=> 'Name of the person'
                ),
                array(
                    "type" => "textfield",
                    "heading" => __("Team Member Position", 'lotus'),
                    "param_name" => "position",
                    "description" => "Position of the person."

                )
            , array(
                    "type" => "attach_image",
                    "heading" => __("Team Member Image", 'lotus'),
                    "param_name" => "images",
                )
            , array(
                    "type" => "textarea",
                    "heading" => __("Team Member Description", 'lotus'),
                    "param_name" => "description",
                    "description" => "Enter a few words that describe the person"
                )
            , array(
                    "type" => "social",
                    "heading" => __("Team Member Social Link", 'lotus'),
                    "param_name" => "social",
                    "description" => "Settings social link for the person"
                )

            )
        ));
    }

    public function engo_render_html($atts, $content = '')
    {
        global $woocommerce_loop;
        $option = engo_get_options();
        extract(shortcode_atts(array(
            'name' => '',
            'position' => '',
            'description' => '',
            'images' => '',
            'social' => ''), $atts));
        ob_start();
        $images = wp_get_attachment_image_src($images, 'medium');
        ?>
        <!-- TEAM MEMBER -->
        <div class="team_item text-center">

            <div class="img">
                <a href=""><img src="<?php echo esc_url($images[0]); ?>" alt="<?php echo esc_attr($name); ?>"></a>
            </div>

            <div class="text">
                <h2><?php echo esc_html($name); ?></h2>
                <?php if ( $position ) : ?>
                    <span><?php echo esc_html($position); ?></span>
                <?php endif; ?>
                <?php echo wpautop($description); ?>
                <?php parse_str(urldecode($social), $social_value); ?>
                <div class="team-share">
                    <?php foreach ($social_value as $k => $item) {
                        $show = ($item=="") ? ' style="display:none"' : "" ;
                        echo '<a href="' . esc_url($item) . '"'.$show.'><i class="fa fa-' . esc_attr($k) . '"></i></a>';
                    } ?>
                </div>
            </div>

        </div>
        <!-- END / TEAM MEMBER -->
        <?php
        return ob_get_clean();
    }

}

if (class_exists('WPBakeryShortCode')) {

    class WPBakeryShortCode_engo_lotus_team extends WPBakeryShortCode
    {

    }

}
